'use strict';

var encoding = require('@cosmjs/encoding');
var zustand = require('zustand');
var middleware = require('zustand/middleware');
var Bt = require('long');
var signClient = require('@walletconnect/sign-client');
var utils = require('@walletconnect/utils');
var reactQuery = require('@tanstack/react-query');
var react = require('react');
var cosmwasmStargate = require('@cosmjs/cosmwasm-stargate');
var stargate = require('@cosmjs/stargate');
var tendermintRpc = require('@cosmjs/tendermint-rpc');
var shallow = require('zustand/shallow');
var jsxRuntime = require('react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Bt__default = /*#__PURE__*/_interopDefault(Bt);

var Wt=Object.defineProperty,vt=Object.defineProperties;var kt=Object.getOwnPropertyDescriptors;var re=Object.getOwnPropertySymbols;var Le=Object.prototype.hasOwnProperty,Ke=Object.prototype.propertyIsEnumerable;var De=(e,t,n)=>t in e?Wt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:n}):e[t]=n,T=(e,t)=>{for(var n in t||(t={}))Le.call(t,n)&&De(e,n,t[n]);if(re)for(var n of re(t))Ke.call(t,n)&&De(e,n,t[n]);return e},N=(e,t)=>vt(e,kt(t));var Ue=(e,t)=>{var n={};for(var i in e)Le.call(e,i)&&t.indexOf(i)<0&&(n[i]=e[i]);if(e!=null&&re)for(var i of re(e))t.indexOf(i)<0&&Ke.call(e,i)&&(n[i]=e[i]);return n};var l=(e,t,n)=>new Promise((i,r)=>{var o=c=>{try{a(n.next(c));}catch(d){r(d);}},s=c=>{try{a(n.throw(c));}catch(d){r(d);}},a=c=>c.done?i(c.value):Promise.resolve(c.value).then(o,s);a((n=n.apply(e,t)).next());});var J="graz-reconnect-session";var qe=(f=>(f.KEPLR="keplr",f.LEAP="leap",f.VECTIS="vectis",f.COSMOSTATION="cosmostation",f.WALLETCONNECT="walletconnect",f.WC_KEPLR_MOBILE="wc_keplr_mobile",f.WC_LEAP_MOBILE="wc_leap_mobile",f.WC_COSMOSTATION_MOBILE="wc_cosmostation_mobile",f.METAMASK_SNAP_LEAP="metamask_snap_leap",f.STATION="station",f.XDEFI="xdefi",f))(qe||{}),Ge=["keplr","leap","vectis","cosmostation","walletconnect","wc_keplr_mobile","wc_leap_mobile","wc_cosmostation_mobile","metamask_snap_leap","station","xdefi"];var Pt={recentChainIds:null,chains:null,chainsConfig:null,multiChainFetchConcurrency:3,walletType:"keplr",walletConnect:{options:null,web3Modal:null},_notFoundFn:()=>null,_onReconnectFailed:()=>null,_reconnect:!1,_reconnectConnector:null},Z={accounts:null,activeChainIds:null,status:"disconnected",wcSignClients:new Map},Nt={name:"graz-session",version:2,partialize:e=>({accounts:e.accounts,activeChainIds:e.activeChainIds}),storage:middleware.createJSONStorage(()=>sessionStorage)},_t={name:"graz-internal",partialize:e=>({recentChainIds:e.recentChainIds,_reconnect:e._reconnect,_reconnectConnector:e._reconnectConnector}),version:2},C=zustand.create(middleware.subscribeWithSelector(middleware.persist(()=>Z,Nt))),u=zustand.create(middleware.subscribeWithSelector(middleware.persist(()=>Pt,_t)));var se=()=>{var e;if(typeof((e=window.cosmostation)==null?void 0:e.providers.keplr)!="undefined"){let t=window.cosmostation.providers.keplr;return Object.assign(t,{subscription:r=>{var s;let o=()=>{F(),r();};return (s=window.cosmostation)==null||s.cosmos.on("accountChanged",o),()=>{var a;(a=window.cosmostation)==null||a.cosmos.off("accountChanged",o);}}})}throw u.getState()._notFoundFn(),new Error("window.cosmostation.providers.keplr is not defined")};var ae=()=>{if(typeof window.keplr!="undefined"){let e=window.keplr;return Object.assign(e,{subscription:i=>{let r=()=>{F(),i();};return window.addEventListener("keplr_keystorechange",r),()=>{window.removeEventListener("keplr_keystorechange",r);}}})}throw u.getState()._notFoundFn(),new Error("window.keplr is not defined")};var ce=()=>{if(typeof window.leap!="undefined"){let e=window.leap;return Object.assign(e,{subscription:i=>{let r=()=>{F(),i();};return window.addEventListener("leap_keystorechange",r),()=>{window.removeEventListener("leap_keystorechange",r);}}})}throw u.getState()._notFoundFn(),new Error("window.leap is not defined")};var je=e=>{let t=window.ethereum;if(t&&e){let n=()=>l(void 0,null,function*(){return yield t.request({method:"wallet_getSnaps"})}),i=h=>l(void 0,null,function*(){try{let w=yield n();return Object.values(w).find(x=>x.id===e.id&&(!h||x.version===h))}catch(w){return}}),r=()=>l(void 0,null,function*(){yield t.request({method:"wallet_requestSnaps",params:{[e.id]:e.params||{}}});}),o=()=>l(void 0,null,function*(){var _;let h=yield t.request({method:"web3_clientVersion"});if(!h.includes("MetaMask"))throw new Error("Metamask is not installed");if(typeof window.okxwallet!="undefined"&&window.okxwallet.isOkxWallet)throw new Error("You have OKX Wallet installed. Please disable and reload the page to use Metamask Snap.");let x=(_=h.split("MetaMask/v")[1])==null?void 0:_.split(".")[0];if(!(Number(x)>=11))throw new Error("Metamask Snap is not supported in this version");return (yield i())||(yield r()),!0}),s=h=>l(void 0,null,function*(){(yield i())||(yield r());}),a=(h,w,x)=>l(void 0,null,function*(){let P=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signDirect",params:{chainId:h,signerAddress:w,signDoc:x}}}}),D=x.accountNumber,_=new Bt__default.default(D.low,D.high,D.unsigned);return {signature:P.signature,signed:N(T({},P.signed),{accountNumber:`${_.toString()}`,authInfoBytes:new Uint8Array(Object.values(P.signed.authInfoBytes)),bodyBytes:new Uint8Array(Object.values(P.signed.bodyBytes))})}}),c=(h,w,x)=>l(void 0,null,function*(){return yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signAmino",params:{chainId:h,signerAddress:w,signDoc:x}}}})}),d=h=>l(void 0,null,function*(){let w=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"getKey",params:{chainId:h}}}});if(!w)throw new Error("No response from Metamask");return w.pubKey=Uint8Array.from(Object.values(w.pubkey)),delete w.pubkey,T({},w)}),g=h=>l(void 0,null,function*(){let w=yield d(h);return {address:w.bech32Address,algo:w.algo,pubkey:w.pubKey}}),f=(...h)=>l(void 0,null,function*(){let[w,x,P,D]=h;return yield c(w,x,P)}),A=(...h)=>l(void 0,null,function*(){let[w,x,P]=h;return yield a(w,x,P)}),S=h=>({getAccounts:()=>l(void 0,null,function*(){return [yield g(h)]}),signDirect:(w,x)=>A(h,w,x)}),b=h=>({getAccounts:()=>l(void 0,null,function*(){return [yield g(h)]}),signAmino:(w,x)=>f(h,w,x)});return {enable:s,experimentalSuggestChain:(...h)=>l(void 0,null,function*(){yield o(),yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"suggestChain",params:{chainInfo:h[0]}}}});}),getKey:d,getOfflineSigner:h=>({getAccounts:()=>l(void 0,null,function*(){return [yield g(h)]}),signDirect:(w,x)=>A(h,w,x),signAmino:(w,x)=>f(h,w,x)}),getOfflineSignerAuto:h=>l(void 0,null,function*(){return (yield d(h)).isNanoLedger?b(h):S(h)}),getOfflineSignerOnlyAmino:b,init:o,signAmino:f,signDirect:A}}throw u.getState()._notFoundFn(),new Error("window.ethereum is not defined")};var $e=()=>je({id:"npm:@leapwallet/metamask-cosmos-snap"});var le=()=>{if(typeof window.station!="undefined"){let e=window.station.keplr;return {subscription:o=>{let s=()=>{F(),o();};return window.addEventListener("station_wallet_change",s),()=>{window.removeEventListener("station_wallet_change",s);}},getKey:o=>l(void 0,null,function*(){let s=yield e.getKey(o);return T({isKeystone:!1},s)}),getOfflineSigner:o=>{try{let s=e.getOfflineSignerOnlyAmino(o);return Object.assign(s,{signDirect:(d,g)=>{throw new Error("signDirect not supported by Station")}})}catch(s){throw console.error(s),s}},experimentalSuggestChain:o=>l(void 0,null,function*(){try{let s=Object.assign(o,{chainSymbolImageUrl:o.chainSymbolImageUrl||"",stakeCurrency:{coinDecimals:o.stakeCurrency.coinDecimals,coinDenom:o.stakeCurrency.coinDenom,coinImageUrl:o.stakeCurrency.coinImageUrl||"",coinMinimalDenom:o.stakeCurrency.coinMinimalDenom},currencies:o.currencies.map(a=>({coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom})),feeCurrencies:o.feeCurrencies.map(a=>{var c,d,g;return {coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom,gasPriceStep:{average:((c=a.gasPriceStep)==null?void 0:c.average)||0,high:((d=a.gasPriceStep)==null?void 0:d.high)||0,low:((g=a.gasPriceStep)==null?void 0:g.low)||0}}})});yield e.experimentalSuggestChain(s);}catch(s){throw console.error(s),s}}),enable:o=>e.enable(o),disable:o=>e.disable(o),getOfflineSignerAuto:o=>e.getOfflineSignerAuto(o),getOfflineSignerOnlyAmino:o=>e.getOfflineSignerOnlyAmino(o),signDirect:()=>e.signDirect(),signAmino:(o,s,a,c)=>e.signAmino(o,s,a)}}throw u.getState()._notFoundFn(),new Error("window.station is not defined")};var ue=()=>{if(typeof window.vectis!="undefined"){let e=window.vectis.cosmos;return {enable:a=>e.enable(a),getOfflineSigner:a=>e.getOfflineSigner(a),getOfflineSignerAuto:a=>e.getOfflineSignerAuto(a),getKey:a=>l(void 0,null,function*(){let c=yield e.getKey(a);return {address:encoding.fromBech32(c.address).data,algo:c.algo,bech32Address:c.address,name:c.name,pubKey:c.pubKey,isKeystone:!1,isNanoLedger:c.isNanoLedger}}),subscription:a=>{let c=()=>{F(),a();};return window.addEventListener("vectis_accountChanged",c),()=>{window.removeEventListener("vectis_accountChanged",c);}},getOfflineSignerOnlyAmino:(...a)=>e.getOfflineSignerAmino(...a),experimentalSuggestChain:(...a)=>l(void 0,null,function*(){let[c]=a,d=N(T({},c),{rpcUrl:c.rpc,restUrl:c.rest,prettyName:c.chainName.replace(" ",""),bech32Prefix:c.bech32Config.bech32PrefixAccAddr});return e.suggestChains([d])}),signDirect:(...a)=>l(void 0,null,function*(){var g;let{1:c,2:d}=a;return e.signDirect(c,{bodyBytes:d.bodyBytes||Uint8Array.from([]),authInfoBytes:d.authInfoBytes||Uint8Array.from([]),accountNumber:Bt__default.default.fromString(((g=d.accountNumber)==null?void 0:g.toString())||"",!1),chainId:d.chainId||""})}),signAmino:(...a)=>l(void 0,null,function*(){let{1:c,2:d}=a;return e.signAmino(c,d)})}}throw u.getState()._notFoundFn(),new Error("window.vectis is not defined")};var Q=()=>typeof window!="undefined"?!!(window.matchMedia("(pointer:coarse)").matches||/Android|webOS|iPhone|iPad|iPod|BlackBerry|Opera Mini/u.test(navigator.userAgent)):!1,He=()=>Q()&&navigator.userAgent.toLowerCase().includes("android"),Ve=()=>Q()&&(navigator.userAgent.toLowerCase().includes("iphone")||navigator.userAgent.toLowerCase().includes("ipad"));var Ie=(e,t,n=new Error("Promise timed out"))=>{let i=new Promise((r,o)=>{setTimeout(()=>{o(n);},t);});return Promise.race([e,i])};var j=e=>{var _,te,Re;if(!((Re=(te=(_=u.getState().walletConnect)==null?void 0:_.options)==null?void 0:te.projectId)!=null&&Re.trim()))throw new Error("walletConnect.options.projectId is not defined");let t=(e==null?void 0:e.walletType)||"walletconnect",n=(e==null?void 0:e.encoding)||"base64",i=m=>{if(!e)return;let{appUrl:p,formatNativeUrl:y}=e;if(Q()){if(He())if(!m)window.open(p.mobile.android,"_self","noreferrer noopener");else {let E=y(p.mobile.android,m,"android");window.open(E,"_self","noreferrer noopener");}if(Ve())if(!m)window.open(p.mobile.ios,"_self","noreferrer noopener");else {let E=y(p.mobile.ios,m,"ios");window.open(E,"_self","noreferrer noopener");}}},r=()=>{let{wcSignClients:m}=C.getState();if(!m.get(t))throw new Error("walletConnect.signClient is not defined");m.delete(t),C.setState({wcSignClients:m}),u.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});},o=m=>l(void 0,null,function*(){let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)throw new Error("walletConnect.signClient is not defined");if(!m)throw new Error("No wallet connect session");yield y.disconnect({topic:m,reason:utils.getSdkError("USER_DISCONNECTED")}),yield c(y);}),s=m=>{try{let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)throw new Error("walletConnect.signClient is not defined");let E=y.session.getAll().at(-1);if(!E)return;if(!(E.expiry*1e3>Date.now()+1e3))throw o(E.topic),new Error("invalid session");try{let M=y.find({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:m.map(U=>`cosmos:${U}`),events:["chainChanged","accountsChanged"]}}});if(!M.length)throw new Error("no session");return M.at(-1)}catch(M){if(!M.message.toLowerCase().includes("no matching key"))throw M}return E}catch(p){if(!p.message.toLowerCase().includes("no matching key"))throw p}},a=m=>{try{return s(m)}catch(p){return}},c=m=>l(void 0,null,function*(){try{let p=m.core.pairing.pairings.getAll({active:!1});if(!p.length)return;yield Promise.all(p.map(y=>l(void 0,null,function*(){yield m.core.pairing.pairings.delete(y.topic,{code:7001,message:"clear pairing"});})));}catch(p){if(!p.message.toLowerCase().includes("no matching key"))throw p}}),d=()=>l(void 0,null,function*(){let{walletConnect:m}=u.getState();if(!(m!=null&&m.options))throw new Error("walletConnect.options is not defined");let{wcSignClients:p}=C.getState(),y=p.get(t);if(y)return y;let E=yield signClient.SignClient.init(m.options);return p.set(t,E),C.setState({wcSignClients:p}),E}),g=m=>{let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)return ()=>{};let E=v=>{let M=C.getState().accounts;if(v.params.event.name==="accountsChanged"&&M&&!Object.values(M).map(U=>U.bech32Address).includes(v.params.event.data[0])){let U=v.params.chainId.split(":")[1];U&&f([U]);}else m();};return y.events.on("session_delete",r),y.events.on("session_expire",r),y.events.on("session_event",E),()=>{y.events.off("session_delete",r),y.events.off("session_expire",r),y.events.off("session_event",E);}},f=m=>l(void 0,null,function*(){var ne;let p=typeof m=="string"?[m]:m,{wcSignClients:y}=C.getState(),E=y.get(t);if(!E)throw new Error("enable walletConnect.signClient is not defined");let{walletConnect:v,chains:M}=u.getState();if(!((ne=v==null?void 0:v.options)!=null&&ne.projectId))throw new Error("walletConnect.options.projectId is not defined");let{Web3Modal:U}=yield import('@web3modal/standalone'),$=new U(T({projectId:v.options.projectId,walletConnectVersion:2,enableExplorer:!1,explorerRecommendedWalletIds:"NONE"},v.web3Modal)),V=a(p);if(!V){let{uri:L,approval:Y}=yield Ie(E.connect({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:p.map(G=>`cosmos:${G}`),events:["chainChanged","accountsChanged"]}}}),15e3,new Error("Connection timeout"));if(!L)throw new Error("No wallet connect uri");e?i(L):yield $.openModal({uri:L});let oe=G=>l(void 0,null,function*(){return G.aborted?Promise.reject(new Error("User closed wallet connect")):new Promise((we,X)=>{Y().then(Pe=>{let Ne=Pe.sessionProperties;if(!Ne)return X(new Error("No session properties"));let Ae=JSON.parse(String(Ne.keys));if(Ae.length===0)return X(new Error("No accounts"));let _e=Ae[0];if(!_e)return X(new Error("No accounts"));let Be={};return p.forEach(ie=>{Be[ie]=N(T({},_e),{bech32Address:encoding.toBech32(M.find(Mt=>Mt.chainId===ie).bech32Config.bech32PrefixAccAddr,encoding.fromBech32(Ae[0].bech32Address).data)});}),C.setState(ie=>({accounts:T(T({},ie.accounts||{}),Be)})),we(Pe)}).catch(X),G.addEventListener("abort",()=>{X(new Error("User closed wallet connect"));},{once:!0});})});try{let G=new AbortController,we=G.signal;$.subscribeModal(X=>{X.open||G.abort();}),yield oe(we);}catch(G){if($.closeModal(),!G.message.toLowerCase().includes("no matching key"))return Promise.reject(G)}return e||$.closeModal(),Promise.resolve()}try{yield Ie((()=>l(void 0,null,function*(){let L=yield S(p[0]),Y={};p.forEach(oe=>{Y[oe]=N(T({},L),{bech32Address:encoding.toBech32(M.find(G=>G.chainId===oe).bech32Config.bech32PrefixAccAddr,encoding.fromBech32(L.bech32Address).data)});}),C.setState({accounts:Y});}))(),15e3,new Error("Connection timeout"));}catch(L){if(o(V.topic),!L.message.toLowerCase().includes("no matching key"))throw L}}),A=m=>l(void 0,null,function*(){var M;let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)throw new Error("walletConnect.signClient is not defined");let E=(M=s([m]))==null?void 0:M.topic;if(!E)throw new Error("No wallet connect session");let v=yield y.request({topic:E,chainId:`cosmos:${m}`,request:{method:"cosmos_getAccounts",params:{}}});if(!v[0])throw new Error("No wallet connect account");return {address:v[0].address,algo:v[0].algo,pubkey:new Uint8Array(Buffer.from(v[0].pubkey,n))}}),S=m=>l(void 0,null,function*(){let p=s([m]);if(!(p!=null&&p.topic))throw new Error("No wallet connect session");let y=p.sessionProperties&&JSON.parse(String(p.sessionProperties.keys))[0];if(!y)throw new Error("No wallet connect key");return y}),b=(...m)=>l(void 0,null,function*(){var L,Y;let[p,y,E]=m,{accounts:v,wcSignClients:M}=C.getState(),U=M.get(t);if(!U)throw new Error("walletConnect.signClient is not defined");if(!v)throw new Error("account is not defined");let $=(L=s([p]))==null?void 0:L.topic;if(!$)throw new Error("No wallet connect session");if(!E.bodyBytes)throw new Error("No bodyBytes");if(!E.authInfoBytes)throw new Error("No authInfoBytes");let V={topic:$,chainId:`cosmos:${p}`,request:{method:"cosmos_signDirect",params:{signerAddress:y,signDoc:N(T({},E),{bodyBytes:Buffer.from(E.bodyBytes).toString(n),authInfoBytes:Buffer.from(E.authInfoBytes).toString(n),accountNumber:(Y=E.accountNumber)==null?void 0:Y.toString()})}}};return i(),yield U.request(V)}),I=(...m)=>l(void 0,null,function*(){let[p,y,E]=m,{signature:v,signed:M}=yield b(p,y,E);return {signed:{chainId:M.chainId,accountNumber:Bt__default.default.fromString(M.accountNumber,!1),authInfoBytes:new Uint8Array(Buffer.from(M.authInfoBytes,n)),bodyBytes:new Uint8Array(Buffer.from(M.bodyBytes,n))},signature:v}}),W=(...m)=>l(void 0,null,function*(){var L;let[p,y,E,v]=m,{wcSignClients:M}=C.getState(),U=M.get(t),{accounts:$}=C.getState();if(!U)throw new Error("walletConnect.signClient is not defined");if(!$)throw new Error("account is not defined");let V=(L=s([p]))==null?void 0:L.topic;if(!V)throw new Error("No wallet connect session");return i(),yield U.request({topic:V,chainId:`cosmos:${p}`,request:{method:"cosmos_signDirect",params:{signerAddress:y,signDoc:E}}})}),R=(...m)=>l(void 0,null,function*(){let[p,y,E,v]=m;return yield W(p,y,E)}),h=m=>({getAccounts:()=>l(void 0,null,function*(){return [yield A(m)]}),signDirect:(p,y)=>I(m,p,y)}),w=m=>({getAccounts:()=>l(void 0,null,function*(){return [yield A(m)]}),signAmino:(p,y)=>R(m,p,y)});return {enable:f,disable:m=>l(void 0,null,function*(){var E;let{wcSignClients:p}=C.getState(),y=p.get(t);if(m===void 0){let v=y==null?void 0:y.session.getAll();v!==void 0&&(yield Promise.all(v.map(M=>o(M.topic))));}else typeof m=="string"?yield o((E=s([m]))==null?void 0:E.topic):yield Promise.all(m.map(v=>{var M;return o((M=s([v]))==null?void 0:M.topic)}));(y==null?void 0:y.session.getAll().length)===0&&r();}),experimentalSuggestChain:(...m)=>l(void 0,null,function*(){yield Promise.reject(new Error("WalletConnect does not support experimentalSuggestChain"));}),getKey:S,getOfflineSigner:m=>({getAccounts:()=>l(void 0,null,function*(){return [yield A(m)]}),signDirect:(p,y)=>I(m,p,y),signAmino:(p,y)=>R(m,p,y)}),getOfflineSignerAuto:m=>l(void 0,null,function*(){return (yield S(m)).isNanoLedger?w(m):h(m)}),getOfflineSignerOnlyAmino:w,signAmino:R,signDirect:I,subscription:g,init:d}};var Je=()=>{var t,n,i;if(!((i=(n=(t=u.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!Q())throw new Error("WalletConnect Cosmostation mobile is only supported in mobile");let e={encoding:"hex",appUrl:{mobile:{ios:"cosmostation://",android:"cosmostation://"}},walletType:"wc_cosmostation_mobile",formatNativeUrl:(r,o,s)=>`${r.replaceAll("/","").replaceAll(":","")}://wc?${o}`};return j(e)};var Ze=()=>{var t,n,i;if(!((i=(n=(t=u.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!Q())throw new Error("WalletConnect Keplr mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"keplrwallet://",android:"intent://"}},walletType:"wc_keplr_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=com.chainapsis.keplr;scheme=keplrwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return j(e)};var et=()=>{var t,n,i;if(!((i=(n=(t=u.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!Q())throw new Error("WalletConnect Leap mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"leapcosmos://",android:"intent://"}},walletType:"wc_leap_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=io.leapwallet.cosmos;scheme=leapwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return j(e)};var de=()=>{var e;if(typeof((e=window.xfi)==null?void 0:e.keplr)!="undefined"){let t=window.xfi.keplr;return Object.assign(t,{subscription:r=>{let o=()=>{F(),r();};return window.addEventListener("keplr_keystorechange",o),()=>{window.removeEventListener("keplr_keystorechange",o);}}})}throw u.getState()._notFoundFn(),new Error("window.xfi.keplr is not defined")};var B=(e=u.getState().walletType)=>{try{return k(e),!0}catch(t){return !1}},F=()=>{window.sessionStorage.removeItem(J),C.setState(Z);},k=(e=u.getState().walletType)=>{switch(e){case"keplr":return ae();case"leap":return ce();case"cosmostation":return se();case"vectis":return ue();case"walletconnect":return j();case"wc_keplr_mobile":return Ze();case"wc_leap_mobile":return et();case"wc_cosmostation_mobile":return Je();case"metamask_snap_leap":return $e();case"station":return le();case"xdefi":return de();default:throw new Error("Unknown wallet type")}},Qo=()=>Object.fromEntries(Ge.map(e=>[e,B(e)])),tt=e=>e==="walletconnect"||e==="wc_keplr_mobile"||e==="wc_leap_mobile"||e==="wc_cosmostation_mobile";var ee=e=>l(void 0,null,function*(){var t;try{let{recentChainIds:n,chains:i,walletType:r}=u.getState(),o=(e==null?void 0:e.walletType)||r;if(!B(o))throw new Error(`${o} is not available`);let a=k(o),c=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:(e==null?void 0:e.chainId)||n;if(!c)throw new Error("No last known connected chain, connect action requires chain ids");let d=i==null?void 0:i.map(S=>S.chainId);c.forEach(S=>{if(!(d!=null&&d.includes(S)))throw new Error(`Chain ${S} is not provided in GrazProvider`)}),C.setState(S=>{let b=u.getState()._reconnect||!!u.getState()._reconnectConnector||!!c;return S.activeChainIds&&c.filter(W=>{var R;return !((R=S.activeChainIds)!=null&&R.includes(W))}).length>0?{status:"connecting"}:b?{status:"reconnecting"}:{status:"connecting"}});let{accounts:g}=C.getState();if(yield (t=a.init)==null?void 0:t.call(a),yield a.enable(c),!tt(o)){let S=yield a.getKey(c[0]),b={};c.forEach(I=>{b[I]=N(T({},S),{bech32Address:encoding.toBech32(i.find(W=>W.chainId===I).bech32Config.bech32PrefixAccAddr,encoding.fromBech32(S.bech32Address).data)});}),C.setState(I=>({accounts:T(T({},I.accounts||{}),b)}));}u.setState(S=>({recentChainIds:[...S.recentChainIds||[],...c].filter((b,I,W)=>W.indexOf(b)===I)})),C.setState(S=>({activeChainIds:[...S.activeChainIds||[],...c].filter((b,I,W)=>W.indexOf(b)===I)})),u.setState({walletType:o,_reconnect:!!(e!=null&&e.autoReconnect),_reconnectConnector:o}),C.setState({status:"connected"}),typeof window!="undefined"&&window.sessionStorage.setItem(J,"Active");let f=c.map(S=>i.find(b=>b.chainId===S));return {accounts:C.getState().accounts,walletType:o,chains:f}}catch(n){throw console.error("connect ",n),C.getState().accounts===null&&C.setState({status:"disconnected"}),C.getState().accounts&&C.getState().activeChainIds&&C.setState({status:"connected"}),n}}),Ee=e=>{typeof window!="undefined"&&window.sessionStorage.removeItem(J);let t=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:e==null?void 0:e.chainId;if(t){let n=C.getState().accounts;t.forEach(r=>{n==null||delete n[r];}),Object.values(n||{}).length===0?(C.setState(Z),u.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null})):(C.setState(r=>{var o;return {activeChainIds:(o=r.activeChainIds)==null?void 0:o.filter(s=>!t.includes(s)),accounts:n}}),u.setState(r=>{var o;return {recentChainIds:(o=r.recentChainIds)==null?void 0:o.filter(s=>!t.includes(s))}}));}else C.setState(Z),u.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});return Promise.resolve()},z=e=>l(void 0,null,function*(){var r;let{recentChainIds:t,_reconnectConnector:n,_reconnect:i}=u.getState();try{let o=B(n||void 0);if(t&&o&&n)return yield ee({chainId:t,walletType:n,autoReconnect:i})}catch(o){(r=e==null?void 0:e.onError)==null||r.call(e,o),Ee();}}),nt=e=>l(void 0,null,function*(){if(!(e!=null&&e.chainId))throw new Error("chainId is required");let{walletType:t}=u.getState(),n=e.walletType||t;if(!B(n))throw new Error(`${n} is not available`);let r=k(n),o=r.getOfflineSigner(e.chainId),s=r.getOfflineSignerOnlyAmino(e.chainId),a=yield r.getOfflineSignerAuto(e.chainId);return {offlineSigner:o,offlineSignerAmino:s,offlineSignerAuto:a}});var Te=()=>{u.setState({recentChainIds:null});},ii=()=>u.getState().recentChainIds,ri=()=>{var n;let{recentChainIds:e,chains:t}=u.getState();return (n=e==null?void 0:e.map(i=>t.find(r=>r.chainId===i)))!=null?n:null},si=({chainId:e})=>{var t;return (t=u.getState().chains)==null?void 0:t.find(n=>n.chainId===e)},ai=({chainId:e})=>{var t;return (t=u.getState().chains)==null?void 0:t.filter(n=>e==null?void 0:e.includes(n.chainId))},be=n=>l(void 0,[n],function*({chainInfo:e,walletType:t}){return yield k(t).experimentalSuggestChain(e),e}),ot=e=>l(void 0,null,function*(){var i;let t=u.getState().walletType;return yield be({chainInfo:e.chainInfo,walletType:(i=e.walletType)!=null?i:t}),yield ee({chainId:e.chainInfo.chainId,walletType:e.walletType,autoReconnect:e.autoReconnect})});var it=e=>(u.setState(t=>({walletConnect:e.walletConnect||t.walletConnect,walletType:e.defaultWallet||t.walletType,chains:e.chains,chainsConfig:e.chainsConfig||t.chainsConfig,multiChainFetchConcurrency:e.multiChainFetchConcurrency||t.multiChainFetchConcurrency,_notFoundFn:e.onNotFound||t._notFoundFn,_onReconnectFailed:e.onReconnectFailed||t._onReconnectFailed,_reconnect:e.autoReconnect===void 0?!0:e.autoReconnect||t._reconnect})),e);var rt=s=>l(void 0,[s],function*({signingClient:e,senderAddress:t,recipientAddress:n,amount:i,fee:r,memo:o}){if(!e)throw new Error("No connected account detected");if(!t)throw new Error("senderAddress is not defined");return e.sendTokens(t,n,i,r,o)}),st=g=>l(void 0,[g],function*({signingClient:e,senderAddress:t,recipientAddress:n,transferAmount:i,sourcePort:r,sourceChannel:o,timeoutHeight:s,timeoutTimestamp:a,fee:c,memo:d}){if(!e)throw new Error("Stargate signing client is not ready");if(!t)throw new Error("senderAddress is not defined");return e.sendIbcTokens(t,n,i,r,o,s,a,c,d)}),at=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,options:r,label:o,codeId:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.instantiate(t,s,n,o,i,r)}),ct=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,contractAddress:r,funds:o,memo:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.execute(t,r,n,i,s,o)}),lt=(e,t,n)=>l(void 0,null,function*(){if(!n)throw new Error("CosmWasm client is not ready");return yield n.queryContractSmart(e,t)}),ut=(e,t,n)=>{if(!n)throw new Error("CosmWasm client is not ready");let i=new TextEncoder().encode(t);return n.queryContractRaw(e,i)};var Ci=e=>e,hi=e=>e;var me=e=>e?Object.keys(e).length===0:!0;var Oe=class extends Error{constructor(t){super(),this.name="AbortError",this.message=t;}},dt=e=>globalThis.DOMException===void 0?new Oe(e):new DOMException(e),mt=e=>{let t=e.reason===void 0?dt("This operation was aborted."):e.reason;return t instanceof Error?t:dt(t)};function xe(o,s){return l(this,arguments,function*(e,t,{concurrency:n=Number.POSITIVE_INFINITY,stopOnError:i=!0,signal:r}={}){return new Promise((a,c)=>{if(e[Symbol.iterator]===void 0&&e[Symbol.asyncIterator]===void 0)throw new TypeError(`Expected \`input\` to be either an \`Iterable\` or \`AsyncIterable\`, got (${typeof e})`);if(typeof t!="function")throw new TypeError("Mapper function is required");if(!((Number.isSafeInteger(n)||n===Number.POSITIVE_INFINITY)&&n>=1))throw new TypeError(`Expected \`concurrency\` to be an integer from 1 and up or \`Infinity\`, got \`${n}\` (${typeof n})`);let d=[],g=[],f=new Map,A=!1,S=!1,b=!1,I=0,W=0,R=e[Symbol.iterator]===void 0?e[Symbol.asyncIterator]():e[Symbol.iterator](),h=x=>{A=!0,S=!0,c(x);};r&&(r.aborted&&h(mt(r)),r.addEventListener("abort",()=>{h(mt(r));}));let w=()=>l(this,null,function*(){if(S)return;let x=yield R.next(),P=W;if(W++,x.done){if(b=!0,I===0&&!S){if(!i&&g.length>0){h(new AggregateError(g));return}if(S=!0,f.size===0){a(d);return}let D=[];for(let[_,te]of d.entries())f.get(_)!==pt&&D.push(te);a(D);}return}I++,l(this,null,function*(){try{let D=yield x.value;if(S)return;let _=yield t(D,P);_===pt&&f.set(P,_),d[P]=_,I--,yield w();}catch(D){if(i)h(D);else {g.push(D),I--;try{yield w();}catch(_){h(_);}}}});});l(this,null,function*(){for(let x=0;x<n;x++){try{yield w();}catch(P){h(P);break}if(b||A)break}});})})}var pt=Symbol("skip");var K=({chainId:e,multiChain:t})=>{let n=u(r=>r.chains);if(!n)throw new Error("No chains found in GrazProvider");let i=typeof e=="string"?[e]:e;switch(!0){case(!!t&&!!i):return i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean);case(!t&&!!i):return [i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean)[0]];case(!!t&&!i):return n;default:return [n[0]]}},q=(e,t,n)=>l(void 0,null,function*(){let i=u.getState().multiChainFetchConcurrency;if(e){let o=yield xe(t,n,{concurrency:i});return Object.fromEntries(o.map((s,a)=>[t[a].chainId,s]))}return yield n(t[0])}),ft=(e,t,n)=>{if(e){let r=t.map(n);return Object.fromEntries(r.map((o,s)=>[t[s].chainId,o]))}return n(t[0])};var ve=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=react.useMemo(()=>["USE_STARGATE_CLIENT",t],[t]);return reactQuery.useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var g;let a=(g=u.getState().chainsConfig)==null?void 0:g[s.chainId],c={url:s.rpc,headers:T({},(a==null?void 0:a.rpcHeaders)||{})};return yield stargate.StargateClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},ke=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=react.useMemo(()=>["USE_COSMWASM_CLIENT",t],[t]);return reactQuery.useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var g;let a=(g=u.getState().chainsConfig)==null?void 0:g[s.chainId],c={url:s.rpc,headers:T({},(a==null?void 0:a.rpcHeaders)||{})};return yield cosmwasmStargate.CosmWasmClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},pe=({type:e,chainId:t,multiChain:n,enabled:i})=>{let r=K({chainId:t,multiChain:n}),o=react.useMemo(()=>["USE_TENDERMINT_CLIENT",e,r],[e,r]);return reactQuery.useQuery({queryKey:o,queryFn:c=>l(void 0,[c],function*({queryKey:[,s,a]}){if(a.length<1)throw new Error("No chains found");return yield q(!!n,a,g=>l(void 0,null,function*(){var I;let f=(I=u.getState().chainsConfig)==null?void 0:I[g.chainId],A={url:g.rpc,headers:T({},(f==null?void 0:f.rpcHeaders)||{})};return yield (s==="tm37"?tendermintRpc.Tendermint37Client:tendermintRpc.Tendermint34Client).connect(A)}))}),enabled:!!r&&r.length>0&&(i!==void 0?!!i:!0),refetchOnWindowFocus:!1})};var Qi=()=>u(e=>({walletType:e.walletType,isCosmostation:e.walletType==="cosmostation",isCosmostationMobile:e.walletType==="wc_cosmostation_mobile",isKeplr:e.walletType==="keplr",isKeplrMobile:e.walletType==="wc_keplr_mobile",isLeap:e.walletType==="leap",isLeapMobile:e.walletType==="wc_leap_mobile",isVectis:e.walletType==="vectis",isWalletConnect:e.walletType==="walletconnect",isMetamaskSnapLeap:e.walletType==="metamask_snap_leap",isStation:e.walletType==="station"}),shallow.shallow),fe=e=>{let n=["USE_CHECK_WALLET",u(r=>e||r.walletType)];return reactQuery.useQuery(n,({queryKey:[,r]})=>B(r))};var H=e=>{let t=u(a=>a.walletType),n=C(a=>a.activeChainIds),i=K({chainId:e!=null&&e.chainId?e.chainId:n||void 0,multiChain:e==null?void 0:e.multiChain}),r=C(a=>a.accounts),o=C(a=>a.status);return react.useEffect(()=>C.subscribe(a=>a.status,(a,c)=>{var d,g,f;if(a==="connected"){let{accounts:A,activeChainIds:S}=C.getState(),{chains:b}=u.getState(),{walletType:I}=u.getState();if(!A||!S||!b)return (d=e==null?void 0:e.onDisconnect)==null?void 0:d.call(e);(g=e==null?void 0:e.onConnect)==null||g.call(e,{accounts:A,chains:S.map(W=>b.find(R=>R.chainId===W)),walletType:I,isReconnect:c==="reconnecting"});}a==="disconnected"&&((f=e==null?void 0:e.onDisconnect)==null||f.call(e));}),[e]),{data:react.useMemo(()=>r?ft(!!(e!=null&&e.multiChain),i,a=>r[a.chainId]):void 0,[r,i,e==null?void 0:e.multiChain]),isConnected:o==="connected",isConnecting:o==="connecting",isDisconnected:o==="disconnected",isReconnecting:o==="reconnecting",isLoading:o==="connecting"||o==="reconnecting",walletType:o==="connected"?t:void 0,reconnect:z,status:o}},Xt=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=H(),i=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),{data:r}=ve({chainId:t.map(s=>s.chainId),multiChain:!0,enabled:((e==null?void 0:e.enabled)===void 0?!0:e.enabled)&&!!i}),o=react.useMemo(()=>["USE_ALL_BALANCES",r,t,i,e==null?void 0:e.chainId],[i,e==null?void 0:e.chainId,t,r]);return reactQuery.useQuery(o,d=>l(void 0,[d],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield q(!!(e!=null&&e.multiChain),a,f=>l(void 0,null,function*(){let A=s==null?void 0:s[f.chainId];if(!A)throw new Error(`Client is not ready ${f.chainId}`);return yield A.getAllBalances(encoding.toBech32(f.bech32Config.bech32PrefixAccAddr,encoding.fromBech32(c).data))}))}),{enabled:!!i&&!!t&&t.length>0&&!me(r)&&((e==null?void 0:e.enabled)===void 0?!0:e.enabled),refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})},ir=e=>{let t=K({chainId:e.chainId}),{data:n}=H({chainId:e.chainId}),i=e.bech32Address||(n==null?void 0:n.bech32Address),{data:r,refetch:o}=Xt({chainId:t.map(c=>c.chainId),bech32Address:i,enabled:!!i&&(e.enabled===void 0?!0:e.enabled)}),s=["USE_BALANCE",e.denom,r,t,i,e.chainId],a=reactQuery.useQuery(s,({queryKey:[,c,d]})=>d==null?void 0:d.find(g=>g.denom===c),{enabled:!!r&&!!(r!=null&&r.length)&&(e.enabled===void 0?!0:e.enabled)});return N(T({},a),{refetch:c=>l(void 0,null,function*(){return yield o(),a.refetch(c)})})},rr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_CONNECT",e,t,n],ee,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=fe();return {connect:s=>r.mutate(s),connectAsync:s=>r.mutateAsync(s),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status}},sr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_DISCONNECT",e,t,n],Ee,{onError:o=>Promise.resolve(e==null?void 0:e(o,void 0)),onMutate:t,onSuccess:()=>Promise.resolve(n==null?void 0:n(void 0))});return {disconnect:o=>r.mutate(o),disconnectAsync:o=>r.mutateAsync(o),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,status:r.status}},ar=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=u(r=>r.walletType),i=react.useMemo(()=>["USE_OFFLINE_SIGNERS",t,n],[t,n]);return reactQuery.useQuery({queryKey:i,queryFn:s=>l(void 0,[s],function*({queryKey:[,r,o]}){if(r.length<1)throw new Error("No chain found");if(!B(o))throw new Error(`${o} is not available`);return yield q(!!(e!=null&&e.multiChain),r,d=>l(void 0,null,function*(){return yield nt({chainId:d.chainId,walletType:o})}))}),enabled:!!t&&t.length>0&&!!n,refetchOnWindowFocus:!1})},cr=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=H(),{data:i}=ve({chainId:t.map(s=>s.chainId),multiChain:!0}),r=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),o=react.useMemo(()=>["USE_BALANCE_STAKED",i,t,r],[t,r,i]);return reactQuery.useQuery(o,d=>l(void 0,[d],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield q(!!(e!=null&&e.multiChain),a,f=>l(void 0,null,function*(){var S;if(!s)throw new Error("Client is not ready");return yield (S=s[f.chainId])==null?void 0:S.getBalanceStaked(encoding.toBech32(f.bech32Config.bech32PrefixAccAddr,encoding.fromBech32(c).data))}))}),{enabled:!!r&&!!t&&t.length>0&&!!i,refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})};var yr=()=>C(e=>e.activeChainIds),Jt=()=>{var e;return (e=C(t=>t.activeChainIds))==null?void 0:e.map(t=>{var i;let n=(i=u.getState().chains)==null?void 0:i.find(r=>r.chainId===t);if(n)return n}).filter(Boolean)},Cr=({chainId:e})=>{var t;return (t=u().chains)==null?void 0:t.find(n=>n.chainId===e)},hr=({chainId:e})=>{var t;return (t=u().chains)==null?void 0:t.filter(n=>e==null?void 0:e.includes(n.chainId))},Sr=({denom:e})=>{let t=Jt();return reactQuery.useQuery(["USE_ACTIVE_CHAIN_CURRENCY",e],({queryKey:[,r]})=>{var o;return (o=t==null?void 0:t.find(s=>s.currencies.find(a=>a.coinMinimalDenom===r)))==null?void 0:o.currencies.find(s=>s)})},wr=e=>{var r;let t=(r=e.status)!=null?r:"BOND_STATUS_BONDED",n=["USE_ACTIVE_CHAIN_VALIDATORS",e.queryClient,t];return reactQuery.useQuery(n,a=>l(void 0,[a],function*({queryKey:[,o,s]}){if(!o)throw new Error("Query client is not defined");return yield o.staking.validators(s)}),{enabled:typeof e.queryClient!="undefined"})},Ar=()=>({data:u(t=>t.recentChainIds),clear:Te}),Ir=()=>{var t;return {data:(t=u(n=>n.recentChainIds))==null?void 0:t.map(n=>{var r;let i=(r=u.getState().chains)==null?void 0:r.find(o=>o.chainId===n);if(i)return i}).filter(Boolean),clear:Te}},Er=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_SUGGEST_CHAIN",e,t,n],be,{onError:(o,s)=>Promise.resolve(e==null?void 0:e(o,s.chainInfo)),onMutate:o=>t==null?void 0:t(o.chainInfo),onSuccess:o=>Promise.resolve(n==null?void 0:n(o))});return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,suggest:r.mutate,suggestAsync:r.mutateAsync,status:r.status}},Tr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_SUGGEST_CHAIN_AND_CONNECT",e,t,n],ot,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:s=>t==null?void 0:t(s),onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=fe();return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status,suggestAndConnect:r.mutate,suggestAndConnectAsync:r.mutateAsync}};var Rr=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=H(),r=i==null?void 0:i.bech32Address,o=reactQuery.useMutation(["USE_SEND_TOKENS",e,t,n,r],s=>rt(T({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendTokens:o.mutate,sendTokensAsync:o.mutateAsync,status:o.status}},Pr=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=H(),r=i==null?void 0:i.bech32Address,o=reactQuery.useMutation(["USE_SEND_IBC_TOKENS",e,t,n,r],s=>st(T({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendIbcTokens:o.mutate,sendIbcTokensAsync:o.mutateAsync,status:o.status}},Nr=({codeId:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=H(),o=r==null?void 0:r.bech32Address,a=reactQuery.useMutation(["USE_INSTANTIATE_CONTRACT",t,n,i,e,o],c=>{var g;if(!o)throw new Error("senderAddress is undefined");let d=N(T({},c),{fee:(g=c.fee)!=null?g:"auto",senderAddress:o,codeId:e});return at(d)},{onError:(c,d)=>Promise.resolve(t==null?void 0:t(c,d)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,instantiateContract:a.mutate,instantiateContractAsync:a.mutateAsync,status:a.status}},_r=({contractAddress:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=H(),o=r==null?void 0:r.bech32Address,a=reactQuery.useMutation(["USE_EXECUTE_CONTRACT",t,n,i,e,o],c=>{var g,f,A;if(!o)throw new Error("senderAddress is undefined");let d=N(T({},c),{fee:(g=c.fee)!=null?g:"auto",senderAddress:o,contractAddress:e,memo:(f=c.memo)!=null?f:"",funds:(A=c.funds)!=null?A:[]});return ct(d)},{onError:(c,d)=>Promise.resolve(t==null?void 0:t(c,d)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,executeContract:a.mutate,executeContractAsync:a.mutateAsync,status:a.status}},Br=e=>{let{data:t}=ke();return reactQuery.useQuery(["USE_QUERY_SMART",e==null?void 0:e.address,e==null?void 0:e.queryMsg,t],({queryKey:[,i]})=>{if(!(e!=null&&e.address)||!e.queryMsg)throw new Error("address or queryMsg undefined");return lt(e.address,e.queryMsg,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.queryMsg)&&!!t})},Dr=e=>{let{data:t}=ke(),n=["USE_QUERY_RAW",e==null?void 0:e.key,e==null?void 0:e.address,t];return reactQuery.useQuery(n,({queryKey:[,r]})=>{if(!(e!=null&&e.address)||!e.key)throw new Error("address or key undefined");return ut(e.address,e.key,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.key)&&!!t})};function Yr(e){let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=u(o=>o.walletType),i=C(o=>o.activeChainIds),r=react.useMemo(()=>["USE_STARGATE_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return reactQuery.useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),o,d=>l(this,null,function*(){var I,W;if(!(i!=null&&i.includes(d.chainId)))return;if(!B(s))throw new Error(`${s} is not available`);let f=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return k(s).getOfflineSigner(d.chainId);case"offlineSignerAuto":return k(s).getOfflineSignerAuto(d.chainId);case"offlineSignerOnlyAmino":return k(s).getOfflineSignerOnlyAmino(d.chainId);default:return k(s).getOfflineSignerAuto(d.chainId)}}))(),A=(I=u.getState().chainsConfig)==null?void 0:I[d.chainId],S={url:d.rpc,headers:T({},(A==null?void 0:A.rpcHeaders)||{})};return (e==null?void 0:e.multiChain)===!0&&e.opts,yield stargate.SigningStargateClient.connectWithSigner(S,f,e!=null&&e.multiChain?(W=e.opts)==null?void 0:W[d.chainId]:e==null?void 0:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Xr(e){let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=u(o=>o.walletType),i=C(o=>o.activeChainIds),r=react.useMemo(()=>["USE_COSMWASM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return reactQuery.useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),o,d=>l(this,null,function*(){var W,R;if(!(i!=null&&i.includes(d.chainId)))return;if(!B(s))throw new Error(`${s} is not available`);let f=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return k(s).getOfflineSigner(d.chainId);case"offlineSignerAuto":return k(s).getOfflineSignerAuto(d.chainId);case"offlineSignerOnlyAmino":return k(s).getOfflineSignerOnlyAmino(d.chainId);default:return k(s).getOfflineSignerAuto(d.chainId)}}))(),A=(W=u.getState().chainsConfig)==null?void 0:W[d.chainId],S={url:d.rpc,headers:T({},(A==null?void 0:A.rpcHeaders)||{})},b=A!=null&&A.gas?stargate.GasPrice.fromString(`${A.gas.price}${A.gas.denom}`):void 0;return yield cosmwasmStargate.SigningCosmWasmClient.connectWithSigner(S,f,T({gasPrice:b},e!=null&&e.multiChain?(R=e.opts)==null?void 0:R[d.chainId]:(e==null?void 0:e.opts)||{}))}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Jr(e){let t=K({chainId:e.chainId,multiChain:e.multiChain}),n=u(s=>s.walletType),i=C(s=>s.activeChainIds),r=react.useMemo(()=>["USE_STARGATE_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=pe({type:e.type,chainId:e.chainId,multiChain:e.multiChain});return reactQuery.useQuery({queryKey:r,queryFn:c=>l(this,[c],function*({queryKey:[,s,a]}){if(s.length<1)throw new Error("No chains found");return yield q(!!e.multiChain,s,g=>l(this,null,function*(){var I;if(!(i!=null&&i.includes(g.chainId)))return;if(!B(a))throw new Error(`${a} is not available`);if(!o)throw new Error("No tendermint client found");let A=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return k(a).getOfflineSigner(g.chainId);case"offlineSignerAuto":return k(a).getOfflineSignerAuto(g.chainId);case"offlineSignerOnlyAmino":return k(a).getOfflineSignerOnlyAmino(g.chainId);default:return k(a).getOfflineSignerAuto(g.chainId)}}))(),S=e.multiChain?o[g.chainId]:o;return yield stargate.SigningStargateClient.createWithSigner(S,A,e.multiChain?(I=e.opts)==null?void 0:I[g.chainId]:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&!!o&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Zr(e){let t=K({chainId:e.chainId,multiChain:e.multiChain}),n=u(a=>a.walletType),i=C(a=>a.activeChainIds),r=react.useMemo(()=>["USE_COSMWASM_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=pe({type:e.type,chainId:e.chainId,multiChain:!1,enabled:!e.multiChain}),{data:s}=pe({type:e.type,chainId:e.chainId,multiChain:!0,enabled:!!e.multiChain});return reactQuery.useQuery({queryKey:r,queryFn:d=>l(this,[d],function*({queryKey:[,a,c]}){if(a.length<1)throw new Error("No chains found");return yield q(!!e.multiChain,a,f=>l(this,null,function*(){var h,w;if(!(i!=null&&i.includes(f.chainId)))return;if(!B(c))throw new Error(`${c} is not available`);let S=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return k(c).getOfflineSigner(f.chainId);case"offlineSignerAuto":return k(c).getOfflineSignerAuto(f.chainId);case"offlineSignerOnlyAmino":return k(c).getOfflineSignerOnlyAmino(f.chainId);default:return k(c).getOfflineSignerAuto(f.chainId)}}))(),b=(h=u.getState().chainsConfig)==null?void 0:h[f.chainId],I=b!=null&&b.gas?stargate.GasPrice.fromString(`${b.gas.price}${b.gas.denom}`):void 0,W=e.multiChain?s==null?void 0:s[f.chainId]:o;if(!W)throw new Error("No tendermint client found");return yield cosmwasmStargate.SigningCosmWasmClient.createWithSigner(W,S,T({gasPrice:I},e.multiChain?(w=e.opts)==null?void 0:w[f.chainId]:e.opts||{}))}))}),enabled:!!t&&t.length>0&&!!n&&(!!o||!me(s))&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}var Tt=({children:e})=>{let[t,n]=react.useState(!1);return react.useEffect(()=>{n(!0);},[]),jsxRuntime.jsx(jsxRuntime.Fragment,{children:t?e:null})};var on=()=>{let e=typeof window!="undefined"&&window.sessionStorage.getItem(J)==="Active",{_reconnect:t,_onReconnectFailed:n,_reconnectConnector:i}=u(),{activeChainIds:r,wcSignClients:o}=C(),s=B(i||void 0);return react.useEffect(()=>{if(i){if(!s)return;e&&r?z({onError:n}):!e&&t&&z({onError:n});}},[s]),react.useEffect(()=>{var a,c,d,g,f,A,S,b,I,W,R,h,w,x;if(i){if(!s)return;i==="cosmostation"&&((c=(a=se()).subscription)==null||c.call(a,()=>{z({onError:n});})),i==="keplr"&&((g=(d=ae()).subscription)==null||g.call(d,()=>{z({onError:n});})),i==="leap"&&((A=(f=ce()).subscription)==null||A.call(f,()=>{z({onError:n});})),i==="vectis"&&((b=(S=ue()).subscription)==null||b.call(S,()=>{z({onError:n});})),i==="walletconnect"&&o.has("walletconnect")&&((W=(I=j()).subscription)==null||W.call(I,()=>{z({onError:n});})),i==="station"&&((h=(R=le()).subscription)==null||h.call(R,()=>{z({onError:n});})),i==="xdefi"&&((x=(w=de()).subscription)==null||x.call(w,()=>{z({onError:n});}));}},[i,o,s]),null},Ot=()=>(on(),null);var an=new reactQuery.QueryClient({}),bs=i=>{var r=i,{children:e,grazOptions:t}=r,n=Ue(r,["children","grazOptions"]);return it(t),jsxRuntime.jsx(reactQuery.QueryClientProvider,N(T({client:an},n),{children:jsxRuntime.jsxs(Tt,{children:[e,jsxRuntime.jsx(Ot,{})]})}),"graz-provider")};

exports.GrazEvents = Ot;
exports.GrazProvider = bs;
exports.WALLET_TYPES = Ge;
exports.WalletType = qe;
exports.checkWallet = B;
exports.clearRecentChain = Te;
exports.clearSession = F;
exports.configureGraz = it;
exports.connect = ee;
exports.defineChainInfo = hi;
exports.defineChains = Ci;
exports.disconnect = Ee;
exports.executeContract = ct;
exports.getAvailableWallets = Qo;
exports.getChainInfo = si;
exports.getChainInfos = ai;
exports.getCosmostation = se;
exports.getKeplr = ae;
exports.getLeap = ce;
exports.getMetamaskSnapLeap = $e;
exports.getOfflineSigners = nt;
exports.getQueryRaw = ut;
exports.getQuerySmart = lt;
exports.getRecentChainIds = ii;
exports.getRecentChains = ri;
exports.getVectis = ue;
exports.getWCCosmostation = Je;
exports.getWCKeplr = Ze;
exports.getWCLeap = et;
exports.getWallet = k;
exports.getWalletConnect = j;
exports.instantiateContract = at;
exports.isWalletConnect = tt;
exports.reconnect = z;
exports.sendIbcTokens = st;
exports.sendTokens = rt;
exports.suggestChain = be;
exports.suggestChainAndConnect = ot;
exports.useAccount = H;
exports.useActiveChainCurrency = Sr;
exports.useActiveChainIds = yr;
exports.useActiveChains = Jt;
exports.useActiveWalletType = Qi;
exports.useBalance = ir;
exports.useBalanceStaked = cr;
exports.useBalances = Xt;
exports.useChainInfo = Cr;
exports.useChainInfos = hr;
exports.useCheckWallet = fe;
exports.useConnect = rr;
exports.useCosmWasmClient = ke;
exports.useCosmWasmSigningClient = Xr;
exports.useCosmWasmTmSigningClient = Zr;
exports.useDisconnect = sr;
exports.useExecuteContract = _r;
exports.useGrazEvents = on;
exports.useInstantiateContract = Nr;
exports.useOfflineSigners = ar;
exports.useQueryClientValidators = wr;
exports.useQueryRaw = Dr;
exports.useQuerySmart = Br;
exports.useRecentChainIds = Ar;
exports.useRecentChains = Ir;
exports.useSendIbcTokens = Pr;
exports.useSendTokens = Rr;
exports.useStargateClient = ve;
exports.useStargateSigningClient = Yr;
exports.useStargateTmSigningClient = Jr;
exports.useSuggestChain = Er;
exports.useSuggestChainAndConnect = Tr;
exports.useTendermintClient = pe;
