import { fromBech32, toBech32 } from '@cosmjs/encoding';
import { create } from 'zustand';
import { createJSONStorage, subscribeWithSelector, persist } from 'zustand/middleware';
import Dt from 'long';
import { SignClient } from '@walletconnect/sign-client';
import { getSdkError } from '@walletconnect/utils';
import { QueryClient, useQuery, useMutation, QueryClientProvider } from '@tanstack/react-query';
import { useMemo, useEffect, useState } from 'react';
import { CosmWasmClient, SigningCosmWasmClient } from '@cosmjs/cosmwasm-stargate';
import { StargateClient, SigningStargateClient, GasPrice } from '@cosmjs/stargate';
import { Tendermint37Client, Tendermint34Client } from '@cosmjs/tendermint-rpc';
import { shallow } from 'zustand/shallow';
import { jsx, jsxs, Fragment } from 'react/jsx-runtime';

var vt=Object.defineProperty,kt=Object.defineProperties;var Rt=Object.getOwnPropertyDescriptors;var se=Object.getOwnPropertySymbols;var Ke=Object.prototype.hasOwnProperty,Ue=Object.prototype.propertyIsEnumerable;var Le=(e,t,n)=>t in e?vt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:n}):e[t]=n,T=(e,t)=>{for(var n in t||(t={}))Ke.call(t,n)&&Le(e,n,t[n]);if(se)for(var n of se(t))Ue.call(t,n)&&Le(e,n,t[n]);return e},_=(e,t)=>kt(e,Rt(t));var qe=(e,t)=>{var n={};for(var i in e)Ke.call(e,i)&&t.indexOf(i)<0&&(n[i]=e[i]);if(e!=null&&se)for(var i of se(e))t.indexOf(i)<0&&Ue.call(e,i)&&(n[i]=e[i]);return n};var l=(e,t,n)=>new Promise((i,r)=>{var o=c=>{try{a(n.next(c));}catch(d){r(d);}},s=c=>{try{a(n.throw(c));}catch(d){r(d);}},a=c=>c.done?i(c.value):Promise.resolve(c.value).then(o,s);a((n=n.apply(e,t)).next());});var Z="graz-reconnect-session";var Ge=(f=>(f.KEPLR="keplr",f.LEAP="leap",f.VECTIS="vectis",f.COSMOSTATION="cosmostation",f.WALLETCONNECT="walletconnect",f.WC_KEPLR_MOBILE="wc_keplr_mobile",f.WC_LEAP_MOBILE="wc_leap_mobile",f.WC_COSMOSTATION_MOBILE="wc_cosmostation_mobile",f.METAMASK_SNAP_LEAP="metamask_snap_leap",f.STATION="station",f.XDEFI="xdefi",f))(Ge||{}),Fe=["keplr","leap","vectis","cosmostation","walletconnect","wc_keplr_mobile","wc_leap_mobile","wc_cosmostation_mobile","metamask_snap_leap","station","xdefi"];var Nt={recentChainIds:null,chains:null,chainsConfig:null,multiChainFetchConcurrency:3,walletType:"keplr",walletConnect:{options:null,web3Modal:null},_notFoundFn:()=>null,_onReconnectFailed:()=>null,_reconnect:!1,_reconnectConnector:null},ee={accounts:null,activeChainIds:null,status:"disconnected",wcSignClients:new Map},_t={name:"graz-session",version:2,partialize:e=>({accounts:e.accounts,activeChainIds:e.activeChainIds}),storage:createJSONStorage(()=>sessionStorage)},Bt={name:"graz-internal",partialize:e=>({recentChainIds:e.recentChainIds,_reconnect:e._reconnect,_reconnectConnector:e._reconnectConnector}),version:2},C=create(subscribeWithSelector(persist(()=>ee,_t))),u=create(subscribeWithSelector(persist(()=>Nt,Bt)));var ae=()=>{var e;if(typeof((e=window.cosmostation)==null?void 0:e.providers.keplr)!="undefined"){let t=window.cosmostation.providers.keplr;return Object.assign(t,{subscription:r=>{var s;let o=()=>{z(),r();};return (s=window.cosmostation)==null||s.cosmos.on("accountChanged",o),()=>{var a;(a=window.cosmostation)==null||a.cosmos.off("accountChanged",o);}}})}throw u.getState()._notFoundFn(),new Error("window.cosmostation.providers.keplr is not defined")};var ce=()=>{if(typeof window.keplr!="undefined"){let e=window.keplr;return Object.assign(e,{subscription:i=>{let r=()=>{z(),i();};return window.addEventListener("keplr_keystorechange",r),()=>{window.removeEventListener("keplr_keystorechange",r);}}})}throw u.getState()._notFoundFn(),new Error("window.keplr is not defined")};var le=()=>{if(typeof window.leap!="undefined"){let e=window.leap;return Object.assign(e,{subscription:i=>{let r=()=>{z(),i();};return window.addEventListener("leap_keystorechange",r),()=>{window.removeEventListener("leap_keystorechange",r);}}})}throw u.getState()._notFoundFn(),new Error("window.leap is not defined")};var $e=e=>{let t=window.ethereum;if(t&&e){let n=()=>l(void 0,null,function*(){return yield t.request({method:"wallet_getSnaps"})}),i=h=>l(void 0,null,function*(){try{let w=yield n();return Object.values(w).find(M=>M.id===e.id&&(!h||M.version===h))}catch(w){return}}),r=()=>l(void 0,null,function*(){yield t.request({method:"wallet_requestSnaps",params:{[e.id]:e.params||{}}});}),o=()=>l(void 0,null,function*(){var B;let h=yield t.request({method:"web3_clientVersion"});if(!h.includes("MetaMask"))throw new Error("Metamask is not installed");if(typeof window.okxwallet!="undefined"&&window.okxwallet.isOkxWallet)throw new Error("You have OKX Wallet installed. Please disable and reload the page to use Metamask Snap.");let M=(B=h.split("MetaMask/v")[1])==null?void 0:B.split(".")[0];if(!(Number(M)>=11))throw new Error("Metamask Snap is not supported in this version");return (yield i())||(yield r()),!0}),s=h=>l(void 0,null,function*(){(yield i())||(yield r());}),a=(h,w,M)=>l(void 0,null,function*(){let N=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signDirect",params:{chainId:h,signerAddress:w,signDoc:M}}}}),L=M.accountNumber,B=new Dt(L.low,L.high,L.unsigned);return {signature:N.signature,signed:_(T({},N.signed),{accountNumber:`${B.toString()}`,authInfoBytes:new Uint8Array(Object.values(N.signed.authInfoBytes)),bodyBytes:new Uint8Array(Object.values(N.signed.bodyBytes))})}}),c=(h,w,M)=>l(void 0,null,function*(){return yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signAmino",params:{chainId:h,signerAddress:w,signDoc:M}}}})}),d=h=>l(void 0,null,function*(){let w=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"getKey",params:{chainId:h}}}});if(!w)throw new Error("No response from Metamask");return w.pubKey=Uint8Array.from(Object.values(w.pubkey)),delete w.pubkey,T({},w)}),g=h=>l(void 0,null,function*(){let w=yield d(h);return {address:w.bech32Address,algo:w.algo,pubkey:w.pubKey}}),f=(...h)=>l(void 0,null,function*(){let[w,M,N,L]=h;return yield c(w,M,N)}),A=(...h)=>l(void 0,null,function*(){let[w,M,N]=h;return yield a(w,M,N)}),S=h=>({getAccounts:()=>l(void 0,null,function*(){return [yield g(h)]}),signDirect:(w,M)=>A(h,w,M)}),b=h=>({getAccounts:()=>l(void 0,null,function*(){return [yield g(h)]}),signAmino:(w,M)=>f(h,w,M)});return {enable:s,experimentalSuggestChain:(...h)=>l(void 0,null,function*(){yield o(),yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"suggestChain",params:{chainInfo:h[0]}}}});}),getKey:d,getOfflineSigner:h=>({getAccounts:()=>l(void 0,null,function*(){return [yield g(h)]}),signDirect:(w,M)=>A(h,w,M),signAmino:(w,M)=>f(h,w,M)}),getOfflineSignerAuto:h=>l(void 0,null,function*(){return (yield d(h)).isNanoLedger?b(h):S(h)}),getOfflineSignerOnlyAmino:b,init:o,signAmino:f,signDirect:A}}throw u.getState()._notFoundFn(),new Error("window.ethereum is not defined")};var He=()=>$e({id:"npm:@leapwallet/metamask-cosmos-snap"});var ue=()=>{if(typeof window.station!="undefined"){let e=window.station.keplr;return {subscription:o=>{let s=()=>{z(),o();};return window.addEventListener("station_wallet_change",s),()=>{window.removeEventListener("station_wallet_change",s);}},getKey:o=>l(void 0,null,function*(){let s=yield e.getKey(o);return T({isKeystone:!1},s)}),getOfflineSigner:o=>{try{let s=e.getOfflineSignerOnlyAmino(o);return Object.assign(s,{signDirect:(d,g)=>{throw new Error("signDirect not supported by Station")}})}catch(s){throw console.error(s),s}},experimentalSuggestChain:o=>l(void 0,null,function*(){try{let s=Object.assign(o,{chainSymbolImageUrl:o.chainSymbolImageUrl||"",stakeCurrency:{coinDecimals:o.stakeCurrency.coinDecimals,coinDenom:o.stakeCurrency.coinDenom,coinImageUrl:o.stakeCurrency.coinImageUrl||"",coinMinimalDenom:o.stakeCurrency.coinMinimalDenom},currencies:o.currencies.map(a=>({coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom})),feeCurrencies:o.feeCurrencies.map(a=>{var c,d,g;return {coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom,gasPriceStep:{average:((c=a.gasPriceStep)==null?void 0:c.average)||0,high:((d=a.gasPriceStep)==null?void 0:d.high)||0,low:((g=a.gasPriceStep)==null?void 0:g.low)||0}}})});yield e.experimentalSuggestChain(s);}catch(s){throw console.error(s),s}}),enable:o=>e.enable(o),disable:o=>e.disable(o),getOfflineSignerAuto:o=>e.getOfflineSignerAuto(o),getOfflineSignerOnlyAmino:o=>e.getOfflineSignerOnlyAmino(o),signDirect:()=>e.signDirect(),signAmino:(o,s,a,c)=>e.signAmino(o,s,a)}}throw u.getState()._notFoundFn(),new Error("window.station is not defined")};var de=()=>{if(typeof window.vectis!="undefined"){let e=window.vectis.cosmos;return {enable:a=>e.enable(a),getOfflineSigner:a=>e.getOfflineSigner(a),getOfflineSignerAuto:a=>e.getOfflineSignerAuto(a),getKey:a=>l(void 0,null,function*(){let c=yield e.getKey(a);return {address:fromBech32(c.address).data,algo:c.algo,bech32Address:c.address,name:c.name,pubKey:c.pubKey,isKeystone:!1,isNanoLedger:c.isNanoLedger}}),subscription:a=>{let c=()=>{z(),a();};return window.addEventListener("vectis_accountChanged",c),()=>{window.removeEventListener("vectis_accountChanged",c);}},getOfflineSignerOnlyAmino:(...a)=>e.getOfflineSignerAmino(...a),experimentalSuggestChain:(...a)=>l(void 0,null,function*(){let[c]=a,d=_(T({},c),{rpcUrl:c.rpc,restUrl:c.rest,prettyName:c.chainName.replace(" ",""),bech32Prefix:c.bech32Config.bech32PrefixAccAddr});return e.suggestChains([d])}),signDirect:(...a)=>l(void 0,null,function*(){var g;let{1:c,2:d}=a;return e.signDirect(c,{bodyBytes:d.bodyBytes||Uint8Array.from([]),authInfoBytes:d.authInfoBytes||Uint8Array.from([]),accountNumber:Dt.fromString(((g=d.accountNumber)==null?void 0:g.toString())||"",!1),chainId:d.chainId||""})}),signAmino:(...a)=>l(void 0,null,function*(){let{1:c,2:d}=a;return e.signAmino(c,d)})}}throw u.getState()._notFoundFn(),new Error("window.vectis is not defined")};var j=()=>typeof window!="undefined"?!!(window.matchMedia("(pointer:coarse)").matches||/Android|webOS|iPhone|iPad|iPod|BlackBerry|Opera Mini/u.test(navigator.userAgent)):!1,Ve=()=>j()&&navigator.userAgent.toLowerCase().includes("android"),Ye=()=>j()&&(navigator.userAgent.toLowerCase().includes("iphone")||navigator.userAgent.toLowerCase().includes("ipad"));var Ee=(e,t,n=new Error("Promise timed out"))=>{let i=new Promise((r,o)=>{setTimeout(()=>{o(n);},t);});return Promise.race([e,i])};var $=e=>{var B,ne,Pe;if(!((Pe=(ne=(B=u.getState().walletConnect)==null?void 0:B.options)==null?void 0:ne.projectId)!=null&&Pe.trim()))throw new Error("walletConnect.options.projectId is not defined");let t=(e==null?void 0:e.walletType)||"walletconnect",n=(e==null?void 0:e.encoding)||"base64",i=m=>{if(!e)return;let{appUrl:p,formatNativeUrl:y}=e;if(j()){if(Ve())if(!m)window.open(p.mobile.android,"_self","noreferrer noopener");else {let E=y(p.mobile.android,m,"android");window.open(E,"_self","noreferrer noopener");}if(Ye())if(!m)window.open(p.mobile.ios,"_self","noreferrer noopener");else {let E=y(p.mobile.ios,m,"ios");window.open(E,"_self","noreferrer noopener");}}},r=()=>{let{wcSignClients:m}=C.getState();if(!m.get(t))throw new Error("walletConnect.signClient is not defined");m.delete(t),C.setState({wcSignClients:m}),u.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});},o=m=>l(void 0,null,function*(){let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)throw new Error("walletConnect.signClient is not defined");if(!m)throw new Error("No wallet connect session");yield y.disconnect({topic:m,reason:getSdkError("USER_DISCONNECTED")}),yield c(y);}),s=m=>{try{let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)throw new Error("walletConnect.signClient is not defined");let E=y.session.getAll().at(-1);if(!E)return;if(!(E.expiry*1e3>Date.now()+1e3))throw o(E.topic),new Error("invalid session");try{let W=y.find({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:m.map(q=>`cosmos:${q}`),events:["chainChanged","accountsChanged"]}}});if(!W.length)throw new Error("no session");return W.at(-1)}catch(W){if(!W.message.toLowerCase().includes("no matching key"))throw W}return E}catch(p){if(!p.message.toLowerCase().includes("no matching key"))throw p}},a=m=>{try{return s(m)}catch(p){return}},c=m=>l(void 0,null,function*(){try{let p=m.core.pairing.pairings.getAll({active:!1});if(!p.length)return;yield Promise.all(p.map(y=>l(void 0,null,function*(){yield m.core.pairing.pairings.delete(y.topic,{code:7001,message:"clear pairing"});})));}catch(p){if(!p.message.toLowerCase().includes("no matching key"))throw p}}),d=()=>l(void 0,null,function*(){let{walletConnect:m}=u.getState();if(!(m!=null&&m.options))throw new Error("walletConnect.options is not defined");let{wcSignClients:p}=C.getState(),y=p.get(t);if(y)return y;let E=yield SignClient.init(m.options);return p.set(t,E),C.setState({wcSignClients:p}),E}),g=m=>{let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)return ()=>{};let E=k=>{let W=C.getState().accounts;if(k.params.event.name==="accountsChanged"&&W&&!Object.values(W).map(q=>q.bech32Address).includes(k.params.event.data[0])){let q=k.params.chainId.split(":")[1];q&&f([q]);}else m();};return y.events.on("session_delete",r),y.events.on("session_expire",r),y.events.on("session_event",E),()=>{y.events.off("session_delete",r),y.events.off("session_expire",r),y.events.off("session_event",E);}},f=m=>l(void 0,null,function*(){var oe;let p=typeof m=="string"?[m]:m,{wcSignClients:y}=C.getState(),E=y.get(t);if(!E)throw new Error("enable walletConnect.signClient is not defined");let{walletConnect:k,chains:W}=u.getState();if(!((oe=k==null?void 0:k.options)!=null&&oe.projectId))throw new Error("walletConnect.options.projectId is not defined");let{Web3Modal:q}=yield import('@web3modal/standalone'),H=new q(T({projectId:k.options.projectId,walletConnectVersion:2,enableExplorer:!1,explorerRecommendedWalletIds:"NONE"},k.web3Modal)),Y=a(p);if(!Y){let{uri:K,approval:X}=yield Ee(E.connect({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:p.map(F=>`cosmos:${F}`),events:["chainChanged","accountsChanged"]}}}),15e3,new Error("Connection timeout"));if(!K)throw new Error("No wallet connect uri");e?i(K):yield H.openModal({uri:K});let ie=F=>l(void 0,null,function*(){return F.aborted?Promise.reject(new Error("User closed wallet connect")):new Promise((Ae,J)=>{X().then(Ne=>{let _e=Ne.sessionProperties;if(!_e)return J(new Error("No session properties"));let Ie=JSON.parse(String(_e.keys));if(Ie.length===0)return J(new Error("No accounts"));let Be=Ie[0];if(!Be)return J(new Error("No accounts"));let De={};return p.forEach(re=>{De[re]=_(T({},Be),{bech32Address:toBech32(W.find(Wt=>Wt.chainId===re).bech32Config.bech32PrefixAccAddr,fromBech32(Ie[0].bech32Address).data)});}),C.setState(re=>({accounts:T(T({},re.accounts||{}),De)})),Ae(Ne)}).catch(J),F.addEventListener("abort",()=>{J(new Error("User closed wallet connect"));},{once:!0});})});try{let F=new AbortController,Ae=F.signal;H.subscribeModal(J=>{J.open||F.abort();}),yield ie(Ae);}catch(F){if(H.closeModal(),!F.message.toLowerCase().includes("no matching key"))return Promise.reject(F)}return e||H.closeModal(),Promise.resolve()}try{yield Ee((()=>l(void 0,null,function*(){let K=yield S(p[0]),X={};p.forEach(ie=>{X[ie]=_(T({},K),{bech32Address:toBech32(W.find(F=>F.chainId===ie).bech32Config.bech32PrefixAccAddr,fromBech32(K.bech32Address).data)});}),C.setState({accounts:X});}))(),15e3,new Error("Connection timeout"));}catch(K){if(o(Y.topic),!K.message.toLowerCase().includes("no matching key"))throw K}}),A=m=>l(void 0,null,function*(){var W;let{wcSignClients:p}=C.getState(),y=p.get(t);if(!y)throw new Error("walletConnect.signClient is not defined");let E=(W=s([m]))==null?void 0:W.topic;if(!E)throw new Error("No wallet connect session");let k=yield y.request({topic:E,chainId:`cosmos:${m}`,request:{method:"cosmos_getAccounts",params:{}}});if(!k[0])throw new Error("No wallet connect account");return {address:k[0].address,algo:k[0].algo,pubkey:new Uint8Array(Buffer.from(k[0].pubkey,n))}}),S=m=>l(void 0,null,function*(){let p=s([m]);if(!(p!=null&&p.topic))throw new Error("No wallet connect session");let y=p.sessionProperties&&JSON.parse(String(p.sessionProperties.keys))[0];if(!y)throw new Error("No wallet connect key");return y}),b=(...m)=>l(void 0,null,function*(){var K,X;let[p,y,E]=m,{accounts:k,wcSignClients:W}=C.getState(),q=W.get(t);if(!q)throw new Error("walletConnect.signClient is not defined");if(!k)throw new Error("account is not defined");let H=(K=s([p]))==null?void 0:K.topic;if(!H)throw new Error("No wallet connect session");if(!E.bodyBytes)throw new Error("No bodyBytes");if(!E.authInfoBytes)throw new Error("No authInfoBytes");let Y={topic:H,chainId:`cosmos:${p}`,request:{method:"cosmos_signDirect",params:{signerAddress:y,signDoc:_(T({},E),{bodyBytes:Buffer.from(E.bodyBytes).toString(n),authInfoBytes:Buffer.from(E.authInfoBytes).toString(n),accountNumber:(X=E.accountNumber)==null?void 0:X.toString()})}}};return i(),yield q.request(Y)}),I=(...m)=>l(void 0,null,function*(){let[p,y,E]=m,{signature:k,signed:W}=yield b(p,y,E);return {signed:{chainId:W.chainId,accountNumber:Dt.fromString(W.accountNumber,!1),authInfoBytes:new Uint8Array(Buffer.from(W.authInfoBytes,n)),bodyBytes:new Uint8Array(Buffer.from(W.bodyBytes,n))},signature:k}}),v=(...m)=>l(void 0,null,function*(){var K;let[p,y,E,k]=m,{wcSignClients:W}=C.getState(),q=W.get(t),{accounts:H}=C.getState();if(!q)throw new Error("walletConnect.signClient is not defined");if(!H)throw new Error("account is not defined");let Y=(K=s([p]))==null?void 0:K.topic;if(!Y)throw new Error("No wallet connect session");return i(),yield q.request({topic:Y,chainId:`cosmos:${p}`,request:{method:"cosmos_signDirect",params:{signerAddress:y,signDoc:E}}})}),P=(...m)=>l(void 0,null,function*(){let[p,y,E,k]=m;return yield v(p,y,E)}),h=m=>({getAccounts:()=>l(void 0,null,function*(){return [yield A(m)]}),signDirect:(p,y)=>I(m,p,y)}),w=m=>({getAccounts:()=>l(void 0,null,function*(){return [yield A(m)]}),signAmino:(p,y)=>P(m,p,y)});return {enable:f,disable:m=>l(void 0,null,function*(){var E;let{wcSignClients:p}=C.getState(),y=p.get(t);if(m===void 0){let k=y==null?void 0:y.session.getAll();k!==void 0&&(yield Promise.all(k.map(W=>o(W.topic))));}else typeof m=="string"?yield o((E=s([m]))==null?void 0:E.topic):yield Promise.all(m.map(k=>{var W;return o((W=s([k]))==null?void 0:W.topic)}));(y==null?void 0:y.session.getAll().length)===0&&r();}),experimentalSuggestChain:(...m)=>l(void 0,null,function*(){yield Promise.reject(new Error("WalletConnect does not support experimentalSuggestChain"));}),getKey:S,getOfflineSigner:m=>({getAccounts:()=>l(void 0,null,function*(){return [yield A(m)]}),signDirect:(p,y)=>I(m,p,y),signAmino:(p,y)=>P(m,p,y)}),getOfflineSignerAuto:m=>l(void 0,null,function*(){return (yield S(m)).isNanoLedger?w(m):h(m)}),getOfflineSignerOnlyAmino:w,signAmino:P,signDirect:I,subscription:g,init:d}};var Ze=()=>{var t,n,i;if(!((i=(n=(t=u.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!j())throw new Error("WalletConnect Cosmostation mobile is only supported in mobile");let e={encoding:"hex",appUrl:{mobile:{ios:"cosmostation://",android:"cosmostation://"}},walletType:"wc_cosmostation_mobile",formatNativeUrl:(r,o,s)=>`${r.replaceAll("/","").replaceAll(":","")}://wc?${o}`};return $(e)};var et=()=>{var t,n,i;if(!((i=(n=(t=u.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!j())throw new Error("WalletConnect Keplr mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"keplrwallet://",android:"intent://"}},walletType:"wc_keplr_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=com.chainapsis.keplr;scheme=keplrwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return $(e)};var tt=()=>{var t,n,i;if(!((i=(n=(t=u.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!j())throw new Error("WalletConnect Leap mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"leapcosmos://",android:"intent://"}},walletType:"wc_leap_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=io.leapwallet.cosmos;scheme=leapwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return $(e)};var me=()=>{var e;if(typeof((e=window.xfi)==null?void 0:e.keplr)!="undefined"){let t=window.xfi.keplr;return Object.assign(t,{subscription:r=>{let o=()=>{z(),r();};return window.addEventListener("keplr_keystorechange",o),()=>{window.removeEventListener("keplr_keystorechange",o);}}})}throw u.getState()._notFoundFn(),new Error("window.xfi.keplr is not defined")};var D=(e=u.getState().walletType)=>{try{return R(e),!0}catch(t){return !1}},z=()=>{window.sessionStorage.removeItem(Z),C.setState(ee);},R=(e=u.getState().walletType)=>{switch(e){case"keplr":return ce();case"leap":return le();case"cosmostation":return ae();case"vectis":return de();case"walletconnect":return $();case"wc_keplr_mobile":return et();case"wc_leap_mobile":return tt();case"wc_cosmostation_mobile":return Ze();case"metamask_snap_leap":return He();case"station":return ue();case"xdefi":return me();default:throw new Error("Unknown wallet type")}},jo=()=>Object.fromEntries(Fe.map(e=>[e,D(e)])),nt=e=>e==="walletconnect"||e==="wc_keplr_mobile"||e==="wc_leap_mobile"||e==="wc_cosmostation_mobile";var te=e=>l(void 0,null,function*(){var t;try{let{recentChainIds:n,chains:i,walletType:r}=u.getState(),o=(e==null?void 0:e.walletType)||r;if(!D(o))throw new Error(`${o} is not available`);let a=R(o),c=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:(e==null?void 0:e.chainId)||n;if(!c)throw new Error("No last known connected chain, connect action requires chain ids");let d=i==null?void 0:i.map(S=>S.chainId);c.forEach(S=>{if(!(d!=null&&d.includes(S)))throw new Error(`Chain ${S} is not provided in GrazProvider`)}),C.setState(S=>{let b=u.getState()._reconnect||!!u.getState()._reconnectConnector||!!c;return S.activeChainIds&&c.filter(v=>{var P;return !((P=S.activeChainIds)!=null&&P.includes(v))}).length>0?{status:"connecting"}:b?{status:"reconnecting"}:{status:"connecting"}});let{accounts:g}=C.getState();if(yield (t=a.init)==null?void 0:t.call(a),yield a.enable(c),!nt(o)){let S=yield a.getKey(c[0]),b={};c.forEach(I=>{b[I]=_(T({},S),{bech32Address:toBech32(i.find(v=>v.chainId===I).bech32Config.bech32PrefixAccAddr,fromBech32(S.bech32Address).data)});}),C.setState(I=>({accounts:T(T({},I.accounts||{}),b)}));}u.setState(S=>({recentChainIds:[...S.recentChainIds||[],...c].filter((b,I,v)=>v.indexOf(b)===I)})),C.setState(S=>({activeChainIds:[...S.activeChainIds||[],...c].filter((b,I,v)=>v.indexOf(b)===I)})),u.setState({walletType:o,_reconnect:!!(e!=null&&e.autoReconnect),_reconnectConnector:o}),C.setState({status:"connected"}),typeof window!="undefined"&&window.sessionStorage.setItem(Z,"Active");let f=c.map(S=>i.find(b=>b.chainId===S));return {accounts:C.getState().accounts,walletType:o,chains:f}}catch(n){throw console.error("connect ",n),C.getState().accounts===null&&C.setState({status:"disconnected"}),C.getState().accounts&&C.getState().activeChainIds&&C.setState({status:"connected"}),n}}),Te=e=>{typeof window!="undefined"&&window.sessionStorage.removeItem(Z);let t=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:e==null?void 0:e.chainId;if(t){let n=C.getState().accounts;t.forEach(r=>{n==null||delete n[r];}),Object.values(n||{}).length===0?(C.setState(ee),u.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null})):(C.setState(r=>{var o;return {activeChainIds:(o=r.activeChainIds)==null?void 0:o.filter(s=>!t.includes(s)),accounts:n}}),u.setState(r=>{var o;return {recentChainIds:(o=r.recentChainIds)==null?void 0:o.filter(s=>!t.includes(s))}}));}else C.setState(ee),u.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});return Promise.resolve()},Q=e=>l(void 0,null,function*(){var r;let{recentChainIds:t,_reconnectConnector:n,_reconnect:i}=u.getState();try{let o=D(n||void 0);if(t&&o&&n)return yield te({chainId:t,walletType:n,autoReconnect:i})}catch(o){(r=e==null?void 0:e.onError)==null||r.call(e,o),Te();}}),ot=e=>l(void 0,null,function*(){if(!(e!=null&&e.chainId))throw new Error("chainId is required");let{walletType:t}=u.getState(),n=e.walletType||t;if(!D(n))throw new Error(`${n} is not available`);let r=R(n),o=r.getOfflineSigner(e.chainId),s=r.getOfflineSignerOnlyAmino(e.chainId),a=yield r.getOfflineSignerAuto(e.chainId);return {offlineSigner:o,offlineSignerAmino:s,offlineSignerAuto:a}});var be=()=>{u.setState({recentChainIds:null});},ri=()=>u.getState().recentChainIds,si=()=>{var n;let{recentChainIds:e,chains:t}=u.getState();return (n=e==null?void 0:e.map(i=>t.find(r=>r.chainId===i)))!=null?n:null},ai=({chainId:e})=>{var t;return (t=u.getState().chains)==null?void 0:t.find(n=>n.chainId===e)},ci=({chainId:e})=>{var t;return (t=u.getState().chains)==null?void 0:t.filter(n=>e==null?void 0:e.includes(n.chainId))},Oe=n=>l(void 0,[n],function*({chainInfo:e,walletType:t}){return yield R(t).experimentalSuggestChain(e),e}),it=e=>l(void 0,null,function*(){var i;let t=u.getState().walletType;return yield Oe({chainInfo:e.chainInfo,walletType:(i=e.walletType)!=null?i:t}),yield te({chainId:e.chainInfo.chainId,walletType:e.walletType,autoReconnect:e.autoReconnect})});var rt=e=>(u.setState(t=>({walletConnect:e.walletConnect||t.walletConnect,walletType:e.defaultWallet||t.walletType,chains:e.chains,chainsConfig:e.chainsConfig||t.chainsConfig,multiChainFetchConcurrency:e.multiChainFetchConcurrency||t.multiChainFetchConcurrency,_notFoundFn:e.onNotFound||t._notFoundFn,_onReconnectFailed:e.onReconnectFailed||t._onReconnectFailed,_reconnect:e.autoReconnect===void 0?!0:e.autoReconnect||t._reconnect})),e);var st=s=>l(void 0,[s],function*({signingClient:e,senderAddress:t,recipientAddress:n,amount:i,fee:r,memo:o}){if(!e)throw new Error("No connected account detected");if(!t)throw new Error("senderAddress is not defined");return e.sendTokens(t,n,i,r,o)}),at=g=>l(void 0,[g],function*({signingClient:e,senderAddress:t,recipientAddress:n,transferAmount:i,sourcePort:r,sourceChannel:o,timeoutHeight:s,timeoutTimestamp:a,fee:c,memo:d}){if(!e)throw new Error("Stargate signing client is not ready");if(!t)throw new Error("senderAddress is not defined");return e.sendIbcTokens(t,n,i,r,o,s,a,c,d)}),ct=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,options:r,label:o,codeId:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.instantiate(t,s,n,o,i,r)}),lt=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,contractAddress:r,funds:o,memo:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.execute(t,r,n,i,s,o)}),ut=(e,t,n)=>l(void 0,null,function*(){if(!n)throw new Error("CosmWasm client is not ready");return yield n.queryContractSmart(e,t)}),dt=(e,t,n)=>{if(!n)throw new Error("CosmWasm client is not ready");let i=new TextEncoder().encode(t);return n.queryContractRaw(e,i)};var hi=e=>e,Si=e=>e;var pe=e=>e?Object.keys(e).length===0:!0;var xe=class extends Error{constructor(t){super(),this.name="AbortError",this.message=t;}},mt=e=>globalThis.DOMException===void 0?new xe(e):new DOMException(e),pt=e=>{let t=e.reason===void 0?mt("This operation was aborted."):e.reason;return t instanceof Error?t:mt(t)};function Me(o,s){return l(this,arguments,function*(e,t,{concurrency:n=Number.POSITIVE_INFINITY,stopOnError:i=!0,signal:r}={}){return new Promise((a,c)=>{if(e[Symbol.iterator]===void 0&&e[Symbol.asyncIterator]===void 0)throw new TypeError(`Expected \`input\` to be either an \`Iterable\` or \`AsyncIterable\`, got (${typeof e})`);if(typeof t!="function")throw new TypeError("Mapper function is required");if(!((Number.isSafeInteger(n)||n===Number.POSITIVE_INFINITY)&&n>=1))throw new TypeError(`Expected \`concurrency\` to be an integer from 1 and up or \`Infinity\`, got \`${n}\` (${typeof n})`);let d=[],g=[],f=new Map,A=!1,S=!1,b=!1,I=0,v=0,P=e[Symbol.iterator]===void 0?e[Symbol.asyncIterator]():e[Symbol.iterator](),h=M=>{A=!0,S=!0,c(M);};r&&(r.aborted&&h(pt(r)),r.addEventListener("abort",()=>{h(pt(r));}));let w=()=>l(this,null,function*(){if(S)return;let M=yield P.next(),N=v;if(v++,M.done){if(b=!0,I===0&&!S){if(!i&&g.length>0){h(new AggregateError(g));return}if(S=!0,f.size===0){a(d);return}let L=[];for(let[B,ne]of d.entries())f.get(B)!==ft&&L.push(ne);a(L);}return}I++,l(this,null,function*(){try{let L=yield M.value;if(S)return;let B=yield t(L,N);B===ft&&f.set(N,B),d[N]=B,I--,yield w();}catch(L){if(i)h(L);else {g.push(L),I--;try{yield w();}catch(B){h(B);}}}});});l(this,null,function*(){for(let M=0;M<n;M++){try{yield w();}catch(N){h(N);break}if(b||A)break}});})})}var ft=Symbol("skip");var U=({chainId:e,multiChain:t})=>{let n=u(r=>r.chains);if(!n)throw new Error("No chains found in GrazProvider");let i=typeof e=="string"?[e]:e;switch(!0){case(!!t&&!!i):return i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean);case(!t&&!!i):return [i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean)[0]];case(!!t&&!i):return n;default:return [n[0]]}},G=(e,t,n)=>l(void 0,null,function*(){let i=u.getState().multiChainFetchConcurrency;if(e){let o=yield Me(t,n,{concurrency:i});return Object.fromEntries(o.map((s,a)=>[t[a].chainId,s]))}return yield n(t[0])}),gt=(e,t,n)=>{if(e){let r=t.map(n);return Object.fromEntries(r.map((o,s)=>[t[s].chainId,o]))}return n(t[0])};var ke=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=useMemo(()=>["USE_STARGATE_CLIENT",t],[t]);return useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var g;let a=(g=u.getState().chainsConfig)==null?void 0:g[s.chainId],c={url:s.rpc,headers:T({},(a==null?void 0:a.rpcHeaders)||{})};return yield StargateClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},Re=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=useMemo(()=>["USE_COSMWASM_CLIENT",t],[t]);return useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var g;let a=(g=u.getState().chainsConfig)==null?void 0:g[s.chainId],c={url:s.rpc,headers:T({},(a==null?void 0:a.rpcHeaders)||{})};return yield CosmWasmClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},fe=({type:e,chainId:t,multiChain:n,enabled:i})=>{let r=U({chainId:t,multiChain:n}),o=useMemo(()=>["USE_TENDERMINT_CLIENT",e,r],[e,r]);return useQuery({queryKey:o,queryFn:c=>l(void 0,[c],function*({queryKey:[,s,a]}){if(a.length<1)throw new Error("No chains found");return yield G(!!n,a,g=>l(void 0,null,function*(){var I;let f=(I=u.getState().chainsConfig)==null?void 0:I[g.chainId],A={url:g.rpc,headers:T({},(f==null?void 0:f.rpcHeaders)||{})};return yield (s==="tm37"?Tendermint37Client:Tendermint34Client).connect(A)}))}),enabled:!!r&&r.length>0&&(i!==void 0?!!i:!0),refetchOnWindowFocus:!1})};var ji=()=>u(e=>({walletType:e.walletType,isCosmostation:e.walletType==="cosmostation",isCosmostationMobile:e.walletType==="wc_cosmostation_mobile",isKeplr:e.walletType==="keplr",isKeplrMobile:e.walletType==="wc_keplr_mobile",isLeap:e.walletType==="leap",isLeapMobile:e.walletType==="wc_leap_mobile",isVectis:e.walletType==="vectis",isWalletConnect:e.walletType==="walletconnect",isMetamaskSnapLeap:e.walletType==="metamask_snap_leap",isStation:e.walletType==="station"}),shallow),ge=e=>{let n=["USE_CHECK_WALLET",u(r=>e||r.walletType)];return useQuery(n,({queryKey:[,r]})=>D(r))};var V=e=>{let t=u(a=>a.walletType),n=C(a=>a.activeChainIds),i=U({chainId:e!=null&&e.chainId?e.chainId:n||void 0,multiChain:e==null?void 0:e.multiChain}),r=C(a=>a.accounts),o=C(a=>a.status);return useEffect(()=>C.subscribe(a=>a.status,(a,c)=>{var d,g,f;if(a==="connected"){let{accounts:A,activeChainIds:S}=C.getState(),{chains:b}=u.getState(),{walletType:I}=u.getState();if(!A||!S||!b)return (d=e==null?void 0:e.onDisconnect)==null?void 0:d.call(e);(g=e==null?void 0:e.onConnect)==null||g.call(e,{accounts:A,chains:S.map(v=>b.find(P=>P.chainId===v)),walletType:I,isReconnect:c==="reconnecting"});}a==="disconnected"&&((f=e==null?void 0:e.onDisconnect)==null||f.call(e));}),[e]),{data:useMemo(()=>r?gt(!!(e!=null&&e.multiChain),i,a=>r[a.chainId]):void 0,[r,i,e==null?void 0:e.multiChain]),isConnected:o==="connected",isConnecting:o==="connecting",isDisconnected:o==="disconnected",isReconnecting:o==="reconnecting",isLoading:o==="connecting"||o==="reconnecting",walletType:o==="connected"?t:void 0,reconnect:Q,status:o}},Jt=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=V(),i=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),{data:r}=ke({chainId:t.map(s=>s.chainId),multiChain:!0,enabled:((e==null?void 0:e.enabled)===void 0?!0:e.enabled)&&!!i}),o=useMemo(()=>["USE_ALL_BALANCES",r,t,i,e==null?void 0:e.chainId],[i,e==null?void 0:e.chainId,t,r]);return useQuery(o,d=>l(void 0,[d],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield G(!!(e!=null&&e.multiChain),a,f=>l(void 0,null,function*(){let A=s==null?void 0:s[f.chainId];if(!A)throw new Error(`Client is not ready ${f.chainId}`);return yield A.getAllBalances(toBech32(f.bech32Config.bech32PrefixAccAddr,fromBech32(c).data))}))}),{enabled:!!i&&!!t&&t.length>0&&!pe(r)&&((e==null?void 0:e.enabled)===void 0?!0:e.enabled),refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})},rr=e=>{let t=U({chainId:e.chainId}),{data:n}=V({chainId:e.chainId}),i=e.bech32Address||(n==null?void 0:n.bech32Address),{data:r,refetch:o}=Jt({chainId:t.map(c=>c.chainId),bech32Address:i,enabled:!!i&&(e.enabled===void 0?!0:e.enabled)}),s=["USE_BALANCE",e.denom,r,t,i,e.chainId],a=useQuery(s,({queryKey:[,c,d]})=>d==null?void 0:d.find(g=>g.denom===c),{enabled:!!r&&!!(r!=null&&r.length)&&(e.enabled===void 0?!0:e.enabled)});return _(T({},a),{refetch:c=>l(void 0,null,function*(){return yield o(),a.refetch(c)})})},sr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_CONNECT",e,t,n],te,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=ge();return {connect:s=>r.mutate(s),connectAsync:s=>r.mutateAsync(s),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status}},ar=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_DISCONNECT",e,t,n],Te,{onError:o=>Promise.resolve(e==null?void 0:e(o,void 0)),onMutate:t,onSuccess:()=>Promise.resolve(n==null?void 0:n(void 0))});return {disconnect:o=>r.mutate(o),disconnectAsync:o=>r.mutateAsync(o),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,status:r.status}},cr=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=u(r=>r.walletType),i=useMemo(()=>["USE_OFFLINE_SIGNERS",t,n],[t,n]);return useQuery({queryKey:i,queryFn:s=>l(void 0,[s],function*({queryKey:[,r,o]}){if(r.length<1)throw new Error("No chain found");if(!D(o))throw new Error(`${o} is not available`);return yield G(!!(e!=null&&e.multiChain),r,d=>l(void 0,null,function*(){return yield ot({chainId:d.chainId,walletType:o})}))}),enabled:!!t&&t.length>0&&!!n,refetchOnWindowFocus:!1})},lr=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=V(),{data:i}=ke({chainId:t.map(s=>s.chainId),multiChain:!0}),r=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),o=useMemo(()=>["USE_BALANCE_STAKED",i,t,r],[t,r,i]);return useQuery(o,d=>l(void 0,[d],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield G(!!(e!=null&&e.multiChain),a,f=>l(void 0,null,function*(){var S;if(!s)throw new Error("Client is not ready");return yield (S=s[f.chainId])==null?void 0:S.getBalanceStaked(toBech32(f.bech32Config.bech32PrefixAccAddr,fromBech32(c).data))}))}),{enabled:!!r&&!!t&&t.length>0&&!!i,refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})};var Cr=()=>C(e=>e.activeChainIds),Zt=()=>{var e;return (e=C(t=>t.activeChainIds))==null?void 0:e.map(t=>{var i;let n=(i=u.getState().chains)==null?void 0:i.find(r=>r.chainId===t);if(n)return n}).filter(Boolean)},hr=({chainId:e})=>{var t;return (t=u().chains)==null?void 0:t.find(n=>n.chainId===e)},Sr=({chainId:e})=>{var t;return (t=u().chains)==null?void 0:t.filter(n=>e==null?void 0:e.includes(n.chainId))},wr=({denom:e})=>{let t=Zt();return useQuery(["USE_ACTIVE_CHAIN_CURRENCY",e],({queryKey:[,r]})=>{var o;return (o=t==null?void 0:t.find(s=>s.currencies.find(a=>a.coinMinimalDenom===r)))==null?void 0:o.currencies.find(s=>s)})},Ar=e=>{var r;let t=(r=e.status)!=null?r:"BOND_STATUS_BONDED",n=["USE_ACTIVE_CHAIN_VALIDATORS",e.queryClient,t];return useQuery(n,a=>l(void 0,[a],function*({queryKey:[,o,s]}){if(!o)throw new Error("Query client is not defined");return yield o.staking.validators(s)}),{enabled:typeof e.queryClient!="undefined"})},Ir=()=>({data:u(t=>t.recentChainIds),clear:be}),Er=()=>{var t;return {data:(t=u(n=>n.recentChainIds))==null?void 0:t.map(n=>{var r;let i=(r=u.getState().chains)==null?void 0:r.find(o=>o.chainId===n);if(i)return i}).filter(Boolean),clear:be}},Tr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_SUGGEST_CHAIN",e,t,n],Oe,{onError:(o,s)=>Promise.resolve(e==null?void 0:e(o,s.chainInfo)),onMutate:o=>t==null?void 0:t(o.chainInfo),onSuccess:o=>Promise.resolve(n==null?void 0:n(o))});return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,suggest:r.mutate,suggestAsync:r.mutateAsync,status:r.status}},br=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_SUGGEST_CHAIN_AND_CONNECT",e,t,n],it,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:s=>t==null?void 0:t(s),onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=ge();return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status,suggestAndConnect:r.mutate,suggestAndConnectAsync:r.mutateAsync}};var Pr=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=V(),r=i==null?void 0:i.bech32Address,o=useMutation(["USE_SEND_TOKENS",e,t,n,r],s=>st(T({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendTokens:o.mutate,sendTokensAsync:o.mutateAsync,status:o.status}},Nr=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=V(),r=i==null?void 0:i.bech32Address,o=useMutation(["USE_SEND_IBC_TOKENS",e,t,n,r],s=>at(T({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendIbcTokens:o.mutate,sendIbcTokensAsync:o.mutateAsync,status:o.status}},_r=({codeId:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=V(),o=r==null?void 0:r.bech32Address,a=useMutation(["USE_INSTANTIATE_CONTRACT",t,n,i,e,o],c=>{var g;if(!o)throw new Error("senderAddress is undefined");let d=_(T({},c),{fee:(g=c.fee)!=null?g:"auto",senderAddress:o,codeId:e});return ct(d)},{onError:(c,d)=>Promise.resolve(t==null?void 0:t(c,d)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,instantiateContract:a.mutate,instantiateContractAsync:a.mutateAsync,status:a.status}},Br=({contractAddress:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=V(),o=r==null?void 0:r.bech32Address,a=useMutation(["USE_EXECUTE_CONTRACT",t,n,i,e,o],c=>{var g,f,A;if(!o)throw new Error("senderAddress is undefined");let d=_(T({},c),{fee:(g=c.fee)!=null?g:"auto",senderAddress:o,contractAddress:e,memo:(f=c.memo)!=null?f:"",funds:(A=c.funds)!=null?A:[]});return lt(d)},{onError:(c,d)=>Promise.resolve(t==null?void 0:t(c,d)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,executeContract:a.mutate,executeContractAsync:a.mutateAsync,status:a.status}},Dr=e=>{let{data:t}=Re();return useQuery(["USE_QUERY_SMART",e==null?void 0:e.address,e==null?void 0:e.queryMsg,t],({queryKey:[,i]})=>{if(!(e!=null&&e.address)||!e.queryMsg)throw new Error("address or queryMsg undefined");return ut(e.address,e.queryMsg,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.queryMsg)&&!!t})},Lr=e=>{let{data:t}=Re(),n=["USE_QUERY_RAW",e==null?void 0:e.key,e==null?void 0:e.address,t];return useQuery(n,({queryKey:[,r]})=>{if(!(e!=null&&e.address)||!e.key)throw new Error("address or key undefined");return dt(e.address,e.key,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.key)&&!!t})};function Xr(e){let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=u(o=>o.walletType),i=C(o=>o.activeChainIds),r=useMemo(()=>["USE_STARGATE_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),o,d=>l(this,null,function*(){var I,v;if(!(i!=null&&i.includes(d.chainId)))return;if(!D(s))throw new Error(`${s} is not available`);let f=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return R(s).getOfflineSigner(d.chainId);case"offlineSignerAuto":return R(s).getOfflineSignerAuto(d.chainId);case"offlineSignerOnlyAmino":return R(s).getOfflineSignerOnlyAmino(d.chainId);default:return R(s).getOfflineSignerAuto(d.chainId)}}))(),A=(I=u.getState().chainsConfig)==null?void 0:I[d.chainId],S={url:d.rpc,headers:T({},(A==null?void 0:A.rpcHeaders)||{})};return (e==null?void 0:e.multiChain)===!0&&e.opts,yield SigningStargateClient.connectWithSigner(S,f,e!=null&&e.multiChain?(v=e.opts)==null?void 0:v[d.chainId]:e==null?void 0:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Jr(e){let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=u(o=>o.walletType),i=C(o=>o.activeChainIds),r=useMemo(()=>["USE_COSMWASM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),o,d=>l(this,null,function*(){var v,P;if(!(i!=null&&i.includes(d.chainId)))return;if(!D(s))throw new Error(`${s} is not available`);let f=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return R(s).getOfflineSigner(d.chainId);case"offlineSignerAuto":return R(s).getOfflineSignerAuto(d.chainId);case"offlineSignerOnlyAmino":return R(s).getOfflineSignerOnlyAmino(d.chainId);default:return R(s).getOfflineSignerAuto(d.chainId)}}))(),A=(v=u.getState().chainsConfig)==null?void 0:v[d.chainId],S={url:d.rpc,headers:T({},(A==null?void 0:A.rpcHeaders)||{})},b=A!=null&&A.gas?GasPrice.fromString(`${A.gas.price}${A.gas.denom}`):void 0;return yield SigningCosmWasmClient.connectWithSigner(S,f,T({gasPrice:b},e!=null&&e.multiChain?(P=e.opts)==null?void 0:P[d.chainId]:(e==null?void 0:e.opts)||{}))}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Zr(e){let t=U({chainId:e.chainId,multiChain:e.multiChain}),n=u(s=>s.walletType),i=C(s=>s.activeChainIds),r=useMemo(()=>["USE_STARGATE_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=fe({type:e.type,chainId:e.chainId,multiChain:e.multiChain});return useQuery({queryKey:r,queryFn:c=>l(this,[c],function*({queryKey:[,s,a]}){if(s.length<1)throw new Error("No chains found");return yield G(!!e.multiChain,s,g=>l(this,null,function*(){var I;if(!(i!=null&&i.includes(g.chainId)))return;if(!D(a))throw new Error(`${a} is not available`);if(!o)throw new Error("No tendermint client found");let A=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return R(a).getOfflineSigner(g.chainId);case"offlineSignerAuto":return R(a).getOfflineSignerAuto(g.chainId);case"offlineSignerOnlyAmino":return R(a).getOfflineSignerOnlyAmino(g.chainId);default:return R(a).getOfflineSignerAuto(g.chainId)}}))(),S=e.multiChain?o[g.chainId]:o;return yield SigningStargateClient.createWithSigner(S,A,e.multiChain?(I=e.opts)==null?void 0:I[g.chainId]:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&!!o&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function es(e){let t=U({chainId:e.chainId,multiChain:e.multiChain}),n=u(a=>a.walletType),i=C(a=>a.activeChainIds),r=useMemo(()=>["USE_COSMWASM_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=fe({type:e.type,chainId:e.chainId,multiChain:!1,enabled:!e.multiChain}),{data:s}=fe({type:e.type,chainId:e.chainId,multiChain:!0,enabled:!!e.multiChain});return useQuery({queryKey:r,queryFn:d=>l(this,[d],function*({queryKey:[,a,c]}){if(a.length<1)throw new Error("No chains found");return yield G(!!e.multiChain,a,f=>l(this,null,function*(){var h,w;if(!(i!=null&&i.includes(f.chainId)))return;if(!D(c))throw new Error(`${c} is not available`);let S=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return R(c).getOfflineSigner(f.chainId);case"offlineSignerAuto":return R(c).getOfflineSignerAuto(f.chainId);case"offlineSignerOnlyAmino":return R(c).getOfflineSignerOnlyAmino(f.chainId);default:return R(c).getOfflineSignerAuto(f.chainId)}}))(),b=(h=u.getState().chainsConfig)==null?void 0:h[f.chainId],I=b!=null&&b.gas?GasPrice.fromString(`${b.gas.price}${b.gas.denom}`):void 0,v=e.multiChain?s==null?void 0:s[f.chainId]:o;if(!v)throw new Error("No tendermint client found");return yield SigningCosmWasmClient.createWithSigner(v,S,T({gasPrice:I},e.multiChain?(w=e.opts)==null?void 0:w[f.chainId]:e.opts||{}))}))}),enabled:!!t&&t.length>0&&!!n&&(!!o||!pe(s))&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}var bt=({children:e})=>{let[t,n]=useState(!1);return useEffect(()=>{n(!0);},[]),jsx(Fragment,{children:t?e:null})};var rn=()=>{let e=typeof window!="undefined"&&window.sessionStorage.getItem(Z)==="Active",{_reconnect:t,_onReconnectFailed:n,_reconnectConnector:i}=u(),{activeChainIds:r,wcSignClients:o}=C(),s=D(i||void 0);return useEffect(()=>{if(i){if(!s)return;e&&r?Q({onError:n}):!e&&t&&Q({onError:n});}},[s]),useEffect(()=>{var a,c,d,g,f,A,S,b,I,v,P,h,w,M;if(i){if(!s)return;i==="cosmostation"&&((c=(a=ae()).subscription)==null||c.call(a,()=>{Q({onError:n});})),i==="keplr"&&((g=(d=ce()).subscription)==null||g.call(d,()=>{Q({onError:n});})),i==="leap"&&((A=(f=le()).subscription)==null||A.call(f,()=>{Q({onError:n});})),i==="vectis"&&((b=(S=de()).subscription)==null||b.call(S,()=>{Q({onError:n});})),i==="walletconnect"&&o.has("walletconnect")&&((v=(I=$()).subscription)==null||v.call(I,()=>{Q({onError:n});})),i==="station"&&((h=(P=ue()).subscription)==null||h.call(P,()=>{Q({onError:n});})),i==="xdefi"&&((M=(w=me()).subscription)==null||M.call(w,()=>{Q({onError:n});}));}},[i,o,s]),null},xt=()=>(rn(),null);var cn=new QueryClient({}),Os=i=>{var r=i,{children:e,grazOptions:t}=r,n=qe(r,["children","grazOptions"]);return rt(t),jsx(QueryClientProvider,_(T({client:cn},n),{children:jsxs(bt,{children:[e,jsx(xt,{})]})}),"graz-provider")};

export { xt as GrazEvents, Os as GrazProvider, Fe as WALLET_TYPES, Ge as WalletType, D as checkWallet, be as clearRecentChain, z as clearSession, rt as configureGraz, te as connect, Si as defineChainInfo, hi as defineChains, Te as disconnect, lt as executeContract, jo as getAvailableWallets, ai as getChainInfo, ci as getChainInfos, ae as getCosmostation, ce as getKeplr, le as getLeap, He as getMetamaskSnapLeap, ot as getOfflineSigners, dt as getQueryRaw, ut as getQuerySmart, ri as getRecentChainIds, si as getRecentChains, de as getVectis, Ze as getWCCosmostation, et as getWCKeplr, tt as getWCLeap, R as getWallet, $ as getWalletConnect, ct as instantiateContract, nt as isWalletConnect, Q as reconnect, at as sendIbcTokens, st as sendTokens, Oe as suggestChain, it as suggestChainAndConnect, V as useAccount, wr as useActiveChainCurrency, Cr as useActiveChainIds, Zt as useActiveChains, ji as useActiveWalletType, rr as useBalance, lr as useBalanceStaked, Jt as useBalances, hr as useChainInfo, Sr as useChainInfos, ge as useCheckWallet, sr as useConnect, Re as useCosmWasmClient, Jr as useCosmWasmSigningClient, es as useCosmWasmTmSigningClient, ar as useDisconnect, Br as useExecuteContract, rn as useGrazEvents, _r as useInstantiateContract, cr as useOfflineSigners, Ar as useQueryClientValidators, Lr as useQueryRaw, Dr as useQuerySmart, Ir as useRecentChainIds, Er as useRecentChains, Nr as useSendIbcTokens, Pr as useSendTokens, ke as useStargateClient, Xr as useStargateSigningClient, Zr as useStargateTmSigningClient, Tr as useSuggestChain, br as useSuggestChainAndConnect, fe as useTendermintClient };
